/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Mode Group</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.ModeGroup#getModes <em>Modes</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ModeGroup#getInitialMode <em>Initial Mode</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getModeGroup()
 * @model
 * @generated
 */
public interface ModeGroup extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Modes</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Mode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Modes</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModeGroup_Modes()
	 * @model containment="true"
	 * @generated
	 */
	EList<Mode> getModes();

	/**
	 * Returns the value of the '<em><b>Initial Mode</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Initial Mode</em>' reference.
	 * @see #setInitialMode(Mode)
	 * @see com.inchron.realtime.root.model.ModelPackage#getModeGroup_InitialMode()
	 * @model required="true"
	 * @generated
	 */
	Mode getInitialMode();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ModeGroup#getInitialMode <em>Initial Mode</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Initial Mode</em>' reference.
	 * @see #getInitialMode()
	 * @generated
	 */
	void setInitialMode(Mode value);

} // ModeGroup
