/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Mode Switch</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.ModeSwitch#getDefaultEntry <em>Default Entry</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ModeSwitch#getEntries <em>Entries</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ModeSwitch#isEvaluateConditionsOnEntry <em>Evaluate Conditions On Entry</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getModeSwitch()
 * @model
 * @generated
 */
public interface ModeSwitch extends GraphEntryBase {
	/**
	 * Returns the value of the '<em><b>Default Entry</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Default Entry</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Default Entry</em>' containment reference.
	 * @see #setDefaultEntry(ModeSwitchDefault)
	 * @see com.inchron.realtime.root.model.ModelPackage#getModeSwitch_DefaultEntry()
	 * @model containment="true"
	 * @generated
	 */
	ModeSwitchDefault getDefaultEntry();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ModeSwitch#getDefaultEntry <em>Default Entry</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Default Entry</em>' containment reference.
	 * @see #getDefaultEntry()
	 * @generated
	 */
	void setDefaultEntry(ModeSwitchDefault value);

	/**
	 * Returns the value of the '<em><b>Entries</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.ModeSwitchEntry}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Entries</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Entries</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModeSwitch_Entries()
	 * @model containment="true"
	 * @generated
	 */
	EList<ModeSwitchEntry> getEntries();

	/**
	 * Returns the value of the '<em><b>Evaluate Conditions On Entry</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Evaluate Conditions On Entry</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Evaluate Conditions On Entry</em>' attribute.
	 * @see #setEvaluateConditionsOnEntry(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getModeSwitch_EvaluateConditionsOnEntry()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isEvaluateConditionsOnEntry();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ModeSwitch#isEvaluateConditionsOnEntry <em>Evaluate Conditions On Entry</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Evaluate Conditions On Entry</em>' attribute.
	 * @see #isEvaluateConditionsOnEntry()
	 * @generated
	 */
	void setEvaluateConditionsOnEntry(boolean value);

} // ModeSwitch
