/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>System</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.System#getCompilerSettings <em>Compiler Settings</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.System#getComponents <em>Components</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.System#getModeConditions <em>Mode Conditions</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.System#getModeGroups <em>Mode Groups</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.System#getRtosModel <em>Rtos Model</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.System#getSpecSettings <em>Spec Settings</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.System#getTranslationUnits <em>Translation Units</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getSystem()
 * @model abstract="true"
 * @generated
 */
public interface System extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Compiler Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Compiler Settings</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Compiler Settings</em>' containment reference.
	 * @see #setCompilerSettings(CompilerSettings)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSystem_CompilerSettings()
	 * @model containment="true"
	 * @generated
	 */
	CompilerSettings getCompilerSettings();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.System#getCompilerSettings <em>Compiler Settings</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Compiler Settings</em>' containment reference.
	 * @see #getCompilerSettings()
	 * @generated
	 */
	void setCompilerSettings(CompilerSettings value);

	/**
	 * Returns the value of the '<em><b>Components</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Component}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Components</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getSystem_Components()
	 * @model containment="true"
	 * @generated
	 */
	EList<Component> getComponents();

	/**
	 * Returns the value of the '<em><b>Mode Conditions</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.ModeCondition}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mode Conditions</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getSystem_ModeConditions()
	 * @model containment="true"
	 * @generated
	 */
	EList<ModeCondition> getModeConditions();

	/**
	 * Returns the value of the '<em><b>Mode Groups</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.ModeGroup}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mode Groups</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mode Groups</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getSystem_ModeGroups()
	 * @model containment="true"
	 * @generated
	 */
	EList<ModeGroup> getModeGroups();

	/**
	 * Returns the value of the '<em><b>Rtos Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Rtos Model</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rtos Model</em>' containment reference.
	 * @see #setRtosModel(RtosModel)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSystem_RtosModel()
	 * @model containment="true"
	 * @generated
	 */
	RtosModel getRtosModel();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.System#getRtosModel <em>Rtos Model</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Rtos Model</em>' containment reference.
	 * @see #getRtosModel()
	 * @generated
	 */
	void setRtosModel(RtosModel value);

	/**
	 * Returns the value of the '<em><b>Spec Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Spec Settings</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Spec Settings</em>' containment reference.
	 * @see #setSpecSettings(SpecSettings)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSystem_SpecSettings()
	 * @model containment="true"
	 * @generated
	 */
	SpecSettings getSpecSettings();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.System#getSpecSettings <em>Spec Settings</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Spec Settings</em>' containment reference.
	 * @see #getSpecSettings()
	 * @generated
	 */
	void setSpecSettings(SpecSettings value);

	/**
	 * Returns the value of the '<em><b>Translation Units</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.TranslationUnit}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Translation Units</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Translation Units</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getSystem_TranslationUnits()
	 * @model containment="true"
	 * @generated
	 */
	EList<TranslationUnit> getTranslationUnits();

} // System
