/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import com.inchron.realtime.root.model.ModelPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.autosar.AutosarFactory
 * @model kind="package"
 * @generated
 */
public interface AutosarPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "autosar";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://inchron.com/realtime/root/2.98.5/model/autosar";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "autosar";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	AutosarPackage eINSTANCE = com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.ARSystemImpl <em>AR System</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.ARSystemImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getARSystem()
	 * @generated
	 */
	int AR_SYSTEM = 0;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AR_SYSTEM__INTRINSIC_ID = ModelPackage.SYSTEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AR_SYSTEM__NAME = ModelPackage.SYSTEM__NAME;

	/**
	 * The feature id for the '<em><b>Compiler Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AR_SYSTEM__COMPILER_SETTINGS = ModelPackage.SYSTEM__COMPILER_SETTINGS;

	/**
	 * The feature id for the '<em><b>Components</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AR_SYSTEM__COMPONENTS = ModelPackage.SYSTEM__COMPONENTS;

	/**
	 * The feature id for the '<em><b>Mode Conditions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AR_SYSTEM__MODE_CONDITIONS = ModelPackage.SYSTEM__MODE_CONDITIONS;

	/**
	 * The feature id for the '<em><b>Mode Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AR_SYSTEM__MODE_GROUPS = ModelPackage.SYSTEM__MODE_GROUPS;

	/**
	 * The feature id for the '<em><b>Rtos Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AR_SYSTEM__RTOS_MODEL = ModelPackage.SYSTEM__RTOS_MODEL;

	/**
	 * The feature id for the '<em><b>Spec Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AR_SYSTEM__SPEC_SETTINGS = ModelPackage.SYSTEM__SPEC_SETTINGS;

	/**
	 * The feature id for the '<em><b>Translation Units</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AR_SYSTEM__TRANSLATION_UNITS = ModelPackage.SYSTEM__TRANSLATION_UNITS;

	/**
	 * The feature id for the '<em><b>Os Config</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AR_SYSTEM__OS_CONFIG = ModelPackage.SYSTEM_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Is Osek</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AR_SYSTEM__IS_OSEK = ModelPackage.SYSTEM_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>AR System</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AR_SYSTEM_FEATURE_COUNT = ModelPackage.SYSTEM_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>AR System</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AR_SYSTEM_OPERATION_COUNT = ModelPackage.SYSTEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.ClearEventImpl <em>Clear Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.ClearEventImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getClearEvent()
	 * @generated
	 */
	int CLEAR_EVENT = 1;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLEAR_EVENT__INTRINSIC_ID = ModelPackage.CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLEAR_EVENT__NAME = ModelPackage.CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLEAR_EVENT__OFFSET = ModelPackage.CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLEAR_EVENT__PERIOD = ModelPackage.CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The feature id for the '<em><b>Events</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLEAR_EVENT__EVENTS = ModelPackage.CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Clear Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLEAR_EVENT_FEATURE_COUNT = ModelPackage.CALL_SEQUENCE_ITEM_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Clear Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLEAR_EVENT_OPERATION_COUNT = ModelPackage.CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.OperationImpl <em>Operation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.OperationImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOperation()
	 * @generated
	 */
	int OPERATION = 2;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The number of structural features of the '<em>Operation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Operation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmImpl <em>Os Alarm</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.OsAlarmImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsAlarm()
	 * @generated
	 */
	int OS_ALARM = 3;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Action</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM__ACTION = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Autostart App Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM__AUTOSTART_APP_MODE = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Autostart Cycle Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM__AUTOSTART_CYCLE_TIME = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Autostart Alarm Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM__AUTOSTART_ALARM_TIME = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Autostart</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM__AUTOSTART = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Counter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM__COUNTER = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Os Alarm</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Os Alarm</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmActionImpl <em>Os Alarm Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.OsAlarmActionImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsAlarmAction()
	 * @generated
	 */
	int OS_ALARM_ACTION = 4;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM_ACTION__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM_ACTION__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM_ACTION__TYPE = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Task</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM_ACTION__TASK = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM_ACTION__EVENT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Callback</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM_ACTION__CALLBACK = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Max Advance</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM_ACTION__MAX_ADVANCE = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Max Retard</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM_ACTION__MAX_RETARD = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Os Alarm Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM_ACTION_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Os Alarm Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ALARM_ACTION_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.OsApplicationImpl <em>Os Application</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.OsApplicationImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsApplication()
	 * @generated
	 */
	int OS_APPLICATION = 5;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_APPLICATION__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_APPLICATION__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Alarms</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_APPLICATION__ALARMS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Counters</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_APPLICATION__COUNTERS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Cpu Core</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_APPLICATION__CPU_CORE = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Partition</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_APPLICATION__PARTITION = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Isrs</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_APPLICATION__ISRS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Schedule Tables</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_APPLICATION__SCHEDULE_TABLES = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Tasks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_APPLICATION__TASKS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Is Trusted</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_APPLICATION__IS_TRUSTED = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Is Trusted With Protection</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_APPLICATION__IS_TRUSTED_WITH_PROTECTION = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 8;

	/**
	 * The number of structural features of the '<em>Os Application</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_APPLICATION_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 9;

	/**
	 * The number of operations of the '<em>Os Application</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_APPLICATION_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.OsConfigImpl <em>Os Config</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.OsConfigImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsConfig()
	 * @generated
	 */
	int OS_CONFIG = 6;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_CONFIG__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_CONFIG__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Alarms</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_CONFIG__ALARMS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Applications</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_CONFIG__APPLICATIONS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Counters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_CONFIG__COUNTERS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_CONFIG__EVENTS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Isrs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_CONFIG__ISRS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Resources</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_CONFIG__RESOURCES = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Schedule Tables</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_CONFIG__SCHEDULE_TABLES = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Spinlocks</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_CONFIG__SPINLOCKS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Tasks</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_CONFIG__TASKS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 8;

	/**
	 * The number of structural features of the '<em>Os Config</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_CONFIG_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 9;

	/**
	 * The number of operations of the '<em>Os Config</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_CONFIG_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.OsCounterImpl <em>Os Counter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.OsCounterImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsCounter()
	 * @generated
	 */
	int OS_COUNTER = 7;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_COUNTER__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_COUNTER__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_COUNTER__CLOCK = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_COUNTER__DELAY = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Granularity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_COUNTER__GRANULARITY = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Hardware</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_COUNTER__HARDWARE = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Mincycle</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_COUNTER__MINCYCLE = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Range</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_COUNTER__RANGE = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Reference Ticks</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_COUNTER__REFERENCE_TICKS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>Os Counter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_COUNTER_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 7;

	/**
	 * The number of operations of the '<em>Os Counter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_COUNTER_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.OsEventImpl <em>Os Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.OsEventImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsEvent()
	 * @generated
	 */
	int OS_EVENT = 8;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_EVENT__INTRINSIC_ID = ModelPackage.EVENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_EVENT__NAME = ModelPackage.EVENT__NAME;

	/**
	 * The feature id for the '<em><b>Mask</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_EVENT__MASK = ModelPackage.EVENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Mask Auto</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_EVENT__MASK_AUTO = ModelPackage.EVENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Os Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_EVENT_FEATURE_COUNT = ModelPackage.EVENT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Os Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_EVENT_OPERATION_COUNT = ModelPackage.EVENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.OsExpiryPointImpl <em>Os Expiry Point</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.OsExpiryPointImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsExpiryPoint()
	 * @generated
	 */
	int OS_EXPIRY_POINT = 9;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_EXPIRY_POINT__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_EXPIRY_POINT__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_EXPIRY_POINT__OFFSET = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Actions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_EXPIRY_POINT__ACTIONS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Os Expiry Point</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_EXPIRY_POINT_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Os Expiry Point</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_EXPIRY_POINT_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.OsIsrImpl <em>Os Isr</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.OsIsrImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsIsr()
	 * @generated
	 */
	int OS_ISR = 10;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__INTRINSIC_ID = ModelPackage.PROCESS__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__NAME = ModelPackage.PROCESS__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__OBJECT_ID = ModelPackage.PROCESS__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Cpu Cores</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__CPU_CORES = ModelPackage.PROCESS__CPU_CORES;

	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__PRIORITY = ModelPackage.PROCESS__PRIORITY;

	/**
	 * The feature id for the '<em><b>Activation Limit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__ACTIVATION_LIMIT = ModelPackage.PROCESS__ACTIVATION_LIMIT;

	/**
	 * The feature id for the '<em><b>Active At Boot</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__ACTIVE_AT_BOOT = ModelPackage.PROCESS__ACTIVE_AT_BOOT;

	/**
	 * The feature id for the '<em><b>Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__CALL_GRAPH = ModelPackage.PROCESS__CALL_GRAPH;

	/**
	 * The feature id for the '<em><b>Deadline</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__DEADLINE = ModelPackage.PROCESS__DEADLINE;

	/**
	 * The feature id for the '<em><b>Extended Task</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__EXTENDED_TASK = ModelPackage.PROCESS__EXTENDED_TASK;

	/**
	 * The feature id for the '<em><b>Trace Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__TRACE_EVENTS = ModelPackage.PROCESS__TRACE_EVENTS;

	/**
	 * The feature id for the '<em><b>Idle Task</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__IDLE_TASK = ModelPackage.PROCESS__IDLE_TASK;

	/**
	 * The feature id for the '<em><b>Isr</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__ISR = ModelPackage.PROCESS__ISR;

	/**
	 * The feature id for the '<em><b>Preemptable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__PREEMPTABLE = ModelPackage.PROCESS__PREEMPTABLE;

	/**
	 * The feature id for the '<em><b>Stack Limit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__STACK_LIMIT = ModelPackage.PROCESS__STACK_LIMIT;

	/**
	 * The feature id for the '<em><b>Triggering Port</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__TRIGGERING_PORT = ModelPackage.PROCESS__TRIGGERING_PORT;

	/**
	 * The feature id for the '<em><b>Resources</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__RESOURCES = ModelPackage.PROCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR__TYPE = ModelPackage.PROCESS_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Os Isr</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR_FEATURE_COUNT = ModelPackage.PROCESS_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Os Isr</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_ISR_OPERATION_COUNT = ModelPackage.PROCESS_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.OsResourceImpl <em>Os Resource</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.OsResourceImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsResource()
	 * @generated
	 */
	int OS_RESOURCE = 11;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_RESOURCE__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_RESOURCE__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_RESOURCE__PROPERTY = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Os Resource</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_RESOURCE_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Os Resource</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_RESOURCE_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.OsScheduleTableImpl <em>Os Schedule Table</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.OsScheduleTableImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsScheduleTable()
	 * @generated
	 */
	int OS_SCHEDULE_TABLE = 12;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SCHEDULE_TABLE__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SCHEDULE_TABLE__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Autostart</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SCHEDULE_TABLE__AUTOSTART = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Counter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SCHEDULE_TABLE__COUNTER = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Duration</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SCHEDULE_TABLE__DURATION = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Expiry Points</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SCHEDULE_TABLE__EXPIRY_POINTS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Repeating</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SCHEDULE_TABLE__REPEATING = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Start Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SCHEDULE_TABLE__START_TYPE = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Os Schedule Table</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SCHEDULE_TABLE_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Os Schedule Table</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SCHEDULE_TABLE_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.OsSpinlockImpl <em>Os Spinlock</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.OsSpinlockImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsSpinlock()
	 * @generated
	 */
	int OS_SPINLOCK = 13;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SPINLOCK__INTRINSIC_ID = ModelPackage.SPINLOCK__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SPINLOCK__NAME = ModelPackage.SPINLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SPINLOCK__OBJECT_ID = ModelPackage.SPINLOCK__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Method</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SPINLOCK__METHOD = ModelPackage.SPINLOCK_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Successor</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SPINLOCK__SUCCESSOR = ModelPackage.SPINLOCK_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Os Spinlock</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SPINLOCK_FEATURE_COUNT = ModelPackage.SPINLOCK_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Os Spinlock</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_SPINLOCK_OPERATION_COUNT = ModelPackage.SPINLOCK_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.OsTaskImpl <em>Os Task</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.OsTaskImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsTask()
	 * @generated
	 */
	int OS_TASK = 14;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__INTRINSIC_ID = ModelPackage.PROCESS__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__NAME = ModelPackage.PROCESS__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__OBJECT_ID = ModelPackage.PROCESS__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Cpu Cores</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__CPU_CORES = ModelPackage.PROCESS__CPU_CORES;

	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__PRIORITY = ModelPackage.PROCESS__PRIORITY;

	/**
	 * The feature id for the '<em><b>Activation Limit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__ACTIVATION_LIMIT = ModelPackage.PROCESS__ACTIVATION_LIMIT;

	/**
	 * The feature id for the '<em><b>Active At Boot</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__ACTIVE_AT_BOOT = ModelPackage.PROCESS__ACTIVE_AT_BOOT;

	/**
	 * The feature id for the '<em><b>Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__CALL_GRAPH = ModelPackage.PROCESS__CALL_GRAPH;

	/**
	 * The feature id for the '<em><b>Deadline</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__DEADLINE = ModelPackage.PROCESS__DEADLINE;

	/**
	 * The feature id for the '<em><b>Extended Task</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__EXTENDED_TASK = ModelPackage.PROCESS__EXTENDED_TASK;

	/**
	 * The feature id for the '<em><b>Trace Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__TRACE_EVENTS = ModelPackage.PROCESS__TRACE_EVENTS;

	/**
	 * The feature id for the '<em><b>Idle Task</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__IDLE_TASK = ModelPackage.PROCESS__IDLE_TASK;

	/**
	 * The feature id for the '<em><b>Isr</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__ISR = ModelPackage.PROCESS__ISR;

	/**
	 * The feature id for the '<em><b>Preemptable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__PREEMPTABLE = ModelPackage.PROCESS__PREEMPTABLE;

	/**
	 * The feature id for the '<em><b>Stack Limit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__STACK_LIMIT = ModelPackage.PROCESS__STACK_LIMIT;

	/**
	 * The feature id for the '<em><b>Triggering Port</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__TRIGGERING_PORT = ModelPackage.PROCESS__TRIGGERING_PORT;

	/**
	 * The feature id for the '<em><b>Events</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__EVENTS = ModelPackage.PROCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Resources</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK__RESOURCES = ModelPackage.PROCESS_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Os Task</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK_FEATURE_COUNT = ModelPackage.PROCESS_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Os Task</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OS_TASK_OPERATION_COUNT = ModelPackage.PROCESS_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.ResumeOSInterruptsImpl <em>Resume OS Interrupts</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.ResumeOSInterruptsImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getResumeOSInterrupts()
	 * @generated
	 */
	int RESUME_OS_INTERRUPTS = 15;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESUME_OS_INTERRUPTS__INTRINSIC_ID = ModelPackage.CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESUME_OS_INTERRUPTS__NAME = ModelPackage.CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESUME_OS_INTERRUPTS__OFFSET = ModelPackage.CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESUME_OS_INTERRUPTS__PERIOD = ModelPackage.CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The number of structural features of the '<em>Resume OS Interrupts</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESUME_OS_INTERRUPTS_FEATURE_COUNT = ModelPackage.CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Resume OS Interrupts</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESUME_OS_INTERRUPTS_OPERATION_COUNT = ModelPackage.CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.RunnableImpl <em>Runnable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.RunnableImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getRunnable()
	 * @generated
	 */
	int RUNNABLE = 16;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNNABLE__INTRINSIC_ID = ModelPackage.FUNCTION__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNNABLE__NAME = ModelPackage.FUNCTION__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNNABLE__OBJECT_ID = ModelPackage.FUNCTION__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNNABLE__CALL_GRAPH = ModelPackage.FUNCTION__CALL_GRAPH;

	/**
	 * The feature id for the '<em><b>Trace Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNNABLE__TRACE_EVENTS = ModelPackage.FUNCTION__TRACE_EVENTS;

	/**
	 * The feature id for the '<em><b>Can Be Invoked Concurrently</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNNABLE__CAN_BE_INVOKED_CONCURRENTLY = ModelPackage.FUNCTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Disabled In Mode</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNNABLE__DISABLED_IN_MODE = ModelPackage.FUNCTION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Runnable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNNABLE_FEATURE_COUNT = ModelPackage.FUNCTION_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Runnable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNNABLE_OPERATION_COUNT = ModelPackage.FUNCTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.ServerCallImpl <em>Server Call</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.ServerCallImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getServerCall()
	 * @generated
	 */
	int SERVER_CALL = 17;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_CALL__INTRINSIC_ID = ModelPackage.CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_CALL__NAME = ModelPackage.CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_CALL__OFFSET = ModelPackage.CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_CALL__PERIOD = ModelPackage.CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The feature id for the '<em><b>Invoked Operation</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_CALL__INVOKED_OPERATION = ModelPackage.CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Server Call</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_CALL_FEATURE_COUNT = ModelPackage.CALL_SEQUENCE_ITEM_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Server Call</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_CALL_OPERATION_COUNT = ModelPackage.CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.SuspendOSInterruptsImpl <em>Suspend OS Interrupts</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.SuspendOSInterruptsImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getSuspendOSInterrupts()
	 * @generated
	 */
	int SUSPEND_OS_INTERRUPTS = 18;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUSPEND_OS_INTERRUPTS__INTRINSIC_ID = ModelPackage.CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUSPEND_OS_INTERRUPTS__NAME = ModelPackage.CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUSPEND_OS_INTERRUPTS__OFFSET = ModelPackage.CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUSPEND_OS_INTERRUPTS__PERIOD = ModelPackage.CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The number of structural features of the '<em>Suspend OS Interrupts</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUSPEND_OS_INTERRUPTS_FEATURE_COUNT = ModelPackage.CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Suspend OS Interrupts</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUSPEND_OS_INTERRUPTS_OPERATION_COUNT = ModelPackage.CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.impl.SwComponentImpl <em>Sw Component</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.impl.SwComponentImpl
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getSwComponent()
	 * @generated
	 */
	int SW_COMPONENT = 19;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SW_COMPONENT__INTRINSIC_ID = ModelPackage.COMPONENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SW_COMPONENT__NAME = ModelPackage.COMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Variables</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SW_COMPONENT__VARIABLES = ModelPackage.COMPONENT__VARIABLES;

	/**
	 * The feature id for the '<em><b>Functions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SW_COMPONENT__FUNCTIONS = ModelPackage.COMPONENT__FUNCTIONS;

	/**
	 * The feature id for the '<em><b>Translation Units</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SW_COMPONENT__TRANSLATION_UNITS = ModelPackage.COMPONENT__TRANSLATION_UNITS;

	/**
	 * The feature id for the '<em><b>Operations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SW_COMPONENT__OPERATIONS = ModelPackage.COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Sw Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SW_COMPONENT_FEATURE_COUNT = ModelPackage.COMPONENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Sw Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SW_COMPONENT_OPERATION_COUNT = ModelPackage.COMPONENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.OsAlarmActionType <em>Os Alarm Action Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.OsAlarmActionType
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsAlarmActionType()
	 * @generated
	 */
	int OS_ALARM_ACTION_TYPE = 20;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.OsIsrType <em>Os Isr Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.OsIsrType
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsIsrType()
	 * @generated
	 */
	int OS_ISR_TYPE = 21;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.OsResourceType <em>Os Resource Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.OsResourceType
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsResourceType()
	 * @generated
	 */
	int OS_RESOURCE_TYPE = 22;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.OsScheduleTableStartType <em>Os Schedule Table Start Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.OsScheduleTableStartType
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsScheduleTableStartType()
	 * @generated
	 */
	int OS_SCHEDULE_TABLE_START_TYPE = 23;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.autosar.OsSpinlockLockMethod <em>Os Spinlock Lock Method</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.autosar.OsSpinlockLockMethod
	 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsSpinlockLockMethod()
	 * @generated
	 */
	int OS_SPINLOCK_LOCK_METHOD = 24;


	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.ARSystem <em>AR System</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>AR System</em>'.
	 * @see com.inchron.realtime.root.model.autosar.ARSystem
	 * @generated
	 */
	EClass getARSystem();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.autosar.ARSystem#getOsConfig <em>Os Config</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Os Config</em>'.
	 * @see com.inchron.realtime.root.model.autosar.ARSystem#getOsConfig()
	 * @see #getARSystem()
	 * @generated
	 */
	EReference getARSystem_OsConfig();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.ARSystem#isIsOsek <em>Is Osek</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Osek</em>'.
	 * @see com.inchron.realtime.root.model.autosar.ARSystem#isIsOsek()
	 * @see #getARSystem()
	 * @generated
	 */
	EAttribute getARSystem_IsOsek();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.ClearEvent <em>Clear Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Clear Event</em>'.
	 * @see com.inchron.realtime.root.model.autosar.ClearEvent
	 * @generated
	 */
	EClass getClearEvent();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.autosar.ClearEvent#getEvents <em>Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Events</em>'.
	 * @see com.inchron.realtime.root.model.autosar.ClearEvent#getEvents()
	 * @see #getClearEvent()
	 * @generated
	 */
	EReference getClearEvent_Events();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.Operation <em>Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Operation</em>'.
	 * @see com.inchron.realtime.root.model.autosar.Operation
	 * @generated
	 */
	EClass getOperation();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.OsAlarm <em>Os Alarm</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Os Alarm</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarm
	 * @generated
	 */
	EClass getOsAlarm();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.autosar.OsAlarm#getAction <em>Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Action</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarm#getAction()
	 * @see #getOsAlarm()
	 * @generated
	 */
	EReference getOsAlarm_Action();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsAlarm#getAutostartAppMode <em>Autostart App Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Autostart App Mode</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarm#getAutostartAppMode()
	 * @see #getOsAlarm()
	 * @generated
	 */
	EAttribute getOsAlarm_AutostartAppMode();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsAlarm#getAutostartCycleTime <em>Autostart Cycle Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Autostart Cycle Time</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarm#getAutostartCycleTime()
	 * @see #getOsAlarm()
	 * @generated
	 */
	EAttribute getOsAlarm_AutostartCycleTime();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsAlarm#getAutostartAlarmTime <em>Autostart Alarm Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Autostart Alarm Time</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarm#getAutostartAlarmTime()
	 * @see #getOsAlarm()
	 * @generated
	 */
	EAttribute getOsAlarm_AutostartAlarmTime();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsAlarm#isAutostart <em>Autostart</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Autostart</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarm#isAutostart()
	 * @see #getOsAlarm()
	 * @generated
	 */
	EAttribute getOsAlarm_Autostart();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.autosar.OsAlarm#getCounter <em>Counter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Counter</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarm#getCounter()
	 * @see #getOsAlarm()
	 * @generated
	 */
	EReference getOsAlarm_Counter();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.OsAlarmAction <em>Os Alarm Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Os Alarm Action</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarmAction
	 * @generated
	 */
	EClass getOsAlarmAction();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarmAction#getType()
	 * @see #getOsAlarmAction()
	 * @generated
	 */
	EAttribute getOsAlarmAction_Type();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getTask <em>Task</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Task</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarmAction#getTask()
	 * @see #getOsAlarmAction()
	 * @generated
	 */
	EReference getOsAlarmAction_Task();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getEvent <em>Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Event</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarmAction#getEvent()
	 * @see #getOsAlarmAction()
	 * @generated
	 */
	EReference getOsAlarmAction_Event();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getCallback <em>Callback</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Callback</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarmAction#getCallback()
	 * @see #getOsAlarmAction()
	 * @generated
	 */
	EReference getOsAlarmAction_Callback();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getMaxAdvance <em>Max Advance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Advance</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarmAction#getMaxAdvance()
	 * @see #getOsAlarmAction()
	 * @generated
	 */
	EAttribute getOsAlarmAction_MaxAdvance();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getMaxRetard <em>Max Retard</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Retard</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarmAction#getMaxRetard()
	 * @see #getOsAlarmAction()
	 * @generated
	 */
	EAttribute getOsAlarmAction_MaxRetard();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.OsApplication <em>Os Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Os Application</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsApplication
	 * @generated
	 */
	EClass getOsApplication();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.autosar.OsApplication#getAlarms <em>Alarms</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Alarms</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsApplication#getAlarms()
	 * @see #getOsApplication()
	 * @generated
	 */
	EReference getOsApplication_Alarms();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.autosar.OsApplication#getCounters <em>Counters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Counters</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsApplication#getCounters()
	 * @see #getOsApplication()
	 * @generated
	 */
	EReference getOsApplication_Counters();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.autosar.OsApplication#getCpuCore <em>Cpu Core</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Cpu Core</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsApplication#getCpuCore()
	 * @see #getOsApplication()
	 * @generated
	 */
	EReference getOsApplication_CpuCore();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.autosar.OsApplication#getPartition <em>Partition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Partition</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsApplication#getPartition()
	 * @see #getOsApplication()
	 * @generated
	 */
	EReference getOsApplication_Partition();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.autosar.OsApplication#getIsrs <em>Isrs</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Isrs</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsApplication#getIsrs()
	 * @see #getOsApplication()
	 * @generated
	 */
	EReference getOsApplication_Isrs();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.autosar.OsApplication#getScheduleTables <em>Schedule Tables</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Schedule Tables</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsApplication#getScheduleTables()
	 * @see #getOsApplication()
	 * @generated
	 */
	EReference getOsApplication_ScheduleTables();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.autosar.OsApplication#getTasks <em>Tasks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Tasks</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsApplication#getTasks()
	 * @see #getOsApplication()
	 * @generated
	 */
	EReference getOsApplication_Tasks();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsApplication#isIsTrusted <em>Is Trusted</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Trusted</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsApplication#isIsTrusted()
	 * @see #getOsApplication()
	 * @generated
	 */
	EAttribute getOsApplication_IsTrusted();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsApplication#isIsTrustedWithProtection <em>Is Trusted With Protection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Trusted With Protection</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsApplication#isIsTrustedWithProtection()
	 * @see #getOsApplication()
	 * @generated
	 */
	EAttribute getOsApplication_IsTrustedWithProtection();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.OsConfig <em>Os Config</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Os Config</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsConfig
	 * @generated
	 */
	EClass getOsConfig();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.autosar.OsConfig#getAlarms <em>Alarms</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Alarms</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsConfig#getAlarms()
	 * @see #getOsConfig()
	 * @generated
	 */
	EReference getOsConfig_Alarms();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.autosar.OsConfig#getApplications <em>Applications</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Applications</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsConfig#getApplications()
	 * @see #getOsConfig()
	 * @generated
	 */
	EReference getOsConfig_Applications();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.autosar.OsConfig#getCounters <em>Counters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Counters</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsConfig#getCounters()
	 * @see #getOsConfig()
	 * @generated
	 */
	EReference getOsConfig_Counters();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.autosar.OsConfig#getEvents <em>Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Events</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsConfig#getEvents()
	 * @see #getOsConfig()
	 * @generated
	 */
	EReference getOsConfig_Events();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.autosar.OsConfig#getIsrs <em>Isrs</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Isrs</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsConfig#getIsrs()
	 * @see #getOsConfig()
	 * @generated
	 */
	EReference getOsConfig_Isrs();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.autosar.OsConfig#getResources <em>Resources</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Resources</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsConfig#getResources()
	 * @see #getOsConfig()
	 * @generated
	 */
	EReference getOsConfig_Resources();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.autosar.OsConfig#getScheduleTables <em>Schedule Tables</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Schedule Tables</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsConfig#getScheduleTables()
	 * @see #getOsConfig()
	 * @generated
	 */
	EReference getOsConfig_ScheduleTables();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.autosar.OsConfig#getSpinlocks <em>Spinlocks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Spinlocks</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsConfig#getSpinlocks()
	 * @see #getOsConfig()
	 * @generated
	 */
	EReference getOsConfig_Spinlocks();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.autosar.OsConfig#getTasks <em>Tasks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Tasks</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsConfig#getTasks()
	 * @see #getOsConfig()
	 * @generated
	 */
	EReference getOsConfig_Tasks();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.OsCounter <em>Os Counter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Os Counter</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsCounter
	 * @generated
	 */
	EClass getOsCounter();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.autosar.OsCounter#getDelay <em>Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Delay</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsCounter#getDelay()
	 * @see #getOsCounter()
	 * @generated
	 */
	EReference getOsCounter_Delay();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsCounter#getGranularity <em>Granularity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Granularity</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsCounter#getGranularity()
	 * @see #getOsCounter()
	 * @generated
	 */
	EAttribute getOsCounter_Granularity();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsCounter#isHardware <em>Hardware</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Hardware</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsCounter#isHardware()
	 * @see #getOsCounter()
	 * @generated
	 */
	EAttribute getOsCounter_Hardware();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsCounter#getMincycle <em>Mincycle</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mincycle</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsCounter#getMincycle()
	 * @see #getOsCounter()
	 * @generated
	 */
	EAttribute getOsCounter_Mincycle();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsCounter#getRange <em>Range</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Range</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsCounter#getRange()
	 * @see #getOsCounter()
	 * @generated
	 */
	EAttribute getOsCounter_Range();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsCounter#getReferenceTicks <em>Reference Ticks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Reference Ticks</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsCounter#getReferenceTicks()
	 * @see #getOsCounter()
	 * @generated
	 */
	EAttribute getOsCounter_ReferenceTicks();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.OsEvent <em>Os Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Os Event</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsEvent
	 * @generated
	 */
	EClass getOsEvent();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsEvent#getMask <em>Mask</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mask</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsEvent#getMask()
	 * @see #getOsEvent()
	 * @generated
	 */
	EAttribute getOsEvent_Mask();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsEvent#isMaskAuto <em>Mask Auto</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mask Auto</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsEvent#isMaskAuto()
	 * @see #getOsEvent()
	 * @generated
	 */
	EAttribute getOsEvent_MaskAuto();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.OsExpiryPoint <em>Os Expiry Point</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Os Expiry Point</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsExpiryPoint
	 * @generated
	 */
	EClass getOsExpiryPoint();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsExpiryPoint#getOffset <em>Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Offset</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsExpiryPoint#getOffset()
	 * @see #getOsExpiryPoint()
	 * @generated
	 */
	EAttribute getOsExpiryPoint_Offset();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.autosar.OsExpiryPoint#getActions <em>Actions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Actions</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsExpiryPoint#getActions()
	 * @see #getOsExpiryPoint()
	 * @generated
	 */
	EReference getOsExpiryPoint_Actions();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.OsIsr <em>Os Isr</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Os Isr</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsIsr
	 * @generated
	 */
	EClass getOsIsr();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.autosar.OsIsr#getResources <em>Resources</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Resources</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsIsr#getResources()
	 * @see #getOsIsr()
	 * @generated
	 */
	EReference getOsIsr_Resources();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsIsr#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsIsr#getType()
	 * @see #getOsIsr()
	 * @generated
	 */
	EAttribute getOsIsr_Type();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.OsResource <em>Os Resource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Os Resource</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsResource
	 * @generated
	 */
	EClass getOsResource();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsResource#getProperty <em>Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Property</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsResource#getProperty()
	 * @see #getOsResource()
	 * @generated
	 */
	EAttribute getOsResource_Property();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.OsScheduleTable <em>Os Schedule Table</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Os Schedule Table</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsScheduleTable
	 * @generated
	 */
	EClass getOsScheduleTable();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#isAutostart <em>Autostart</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Autostart</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsScheduleTable#isAutostart()
	 * @see #getOsScheduleTable()
	 * @generated
	 */
	EAttribute getOsScheduleTable_Autostart();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#getCounter <em>Counter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Counter</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsScheduleTable#getCounter()
	 * @see #getOsScheduleTable()
	 * @generated
	 */
	EReference getOsScheduleTable_Counter();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#getDuration <em>Duration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Duration</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsScheduleTable#getDuration()
	 * @see #getOsScheduleTable()
	 * @generated
	 */
	EAttribute getOsScheduleTable_Duration();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#getExpiryPoints <em>Expiry Points</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Expiry Points</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsScheduleTable#getExpiryPoints()
	 * @see #getOsScheduleTable()
	 * @generated
	 */
	EReference getOsScheduleTable_ExpiryPoints();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#isRepeating <em>Repeating</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Repeating</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsScheduleTable#isRepeating()
	 * @see #getOsScheduleTable()
	 * @generated
	 */
	EAttribute getOsScheduleTable_Repeating();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#getStartType <em>Start Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Start Type</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsScheduleTable#getStartType()
	 * @see #getOsScheduleTable()
	 * @generated
	 */
	EAttribute getOsScheduleTable_StartType();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.OsSpinlock <em>Os Spinlock</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Os Spinlock</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsSpinlock
	 * @generated
	 */
	EClass getOsSpinlock();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.OsSpinlock#getMethod <em>Method</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Method</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsSpinlock#getMethod()
	 * @see #getOsSpinlock()
	 * @generated
	 */
	EAttribute getOsSpinlock_Method();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.autosar.OsSpinlock#getSuccessor <em>Successor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Successor</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsSpinlock#getSuccessor()
	 * @see #getOsSpinlock()
	 * @generated
	 */
	EReference getOsSpinlock_Successor();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.OsTask <em>Os Task</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Os Task</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsTask
	 * @generated
	 */
	EClass getOsTask();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.autosar.OsTask#getEvents <em>Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Events</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsTask#getEvents()
	 * @see #getOsTask()
	 * @generated
	 */
	EReference getOsTask_Events();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.autosar.OsTask#getResources <em>Resources</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Resources</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsTask#getResources()
	 * @see #getOsTask()
	 * @generated
	 */
	EReference getOsTask_Resources();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.ResumeOSInterrupts <em>Resume OS Interrupts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Resume OS Interrupts</em>'.
	 * @see com.inchron.realtime.root.model.autosar.ResumeOSInterrupts
	 * @generated
	 */
	EClass getResumeOSInterrupts();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.Runnable <em>Runnable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Runnable</em>'.
	 * @see com.inchron.realtime.root.model.autosar.Runnable
	 * @generated
	 */
	EClass getRunnable();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.autosar.Runnable#isCanBeInvokedConcurrently <em>Can Be Invoked Concurrently</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Can Be Invoked Concurrently</em>'.
	 * @see com.inchron.realtime.root.model.autosar.Runnable#isCanBeInvokedConcurrently()
	 * @see #getRunnable()
	 * @generated
	 */
	EAttribute getRunnable_CanBeInvokedConcurrently();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.autosar.Runnable#getDisabledInMode <em>Disabled In Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Disabled In Mode</em>'.
	 * @see com.inchron.realtime.root.model.autosar.Runnable#getDisabledInMode()
	 * @see #getRunnable()
	 * @generated
	 */
	EReference getRunnable_DisabledInMode();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.ServerCall <em>Server Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Server Call</em>'.
	 * @see com.inchron.realtime.root.model.autosar.ServerCall
	 * @generated
	 */
	EClass getServerCall();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.autosar.ServerCall#getInvokedOperation <em>Invoked Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Invoked Operation</em>'.
	 * @see com.inchron.realtime.root.model.autosar.ServerCall#getInvokedOperation()
	 * @see #getServerCall()
	 * @generated
	 */
	EReference getServerCall_InvokedOperation();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.SuspendOSInterrupts <em>Suspend OS Interrupts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Suspend OS Interrupts</em>'.
	 * @see com.inchron.realtime.root.model.autosar.SuspendOSInterrupts
	 * @generated
	 */
	EClass getSuspendOSInterrupts();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.autosar.SwComponent <em>Sw Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sw Component</em>'.
	 * @see com.inchron.realtime.root.model.autosar.SwComponent
	 * @generated
	 */
	EClass getSwComponent();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.autosar.SwComponent#getOperations <em>Operations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Operations</em>'.
	 * @see com.inchron.realtime.root.model.autosar.SwComponent#getOperations()
	 * @see #getSwComponent()
	 * @generated
	 */
	EReference getSwComponent_Operations();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.autosar.OsAlarmActionType <em>Os Alarm Action Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Os Alarm Action Type</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarmActionType
	 * @generated
	 */
	EEnum getOsAlarmActionType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.autosar.OsIsrType <em>Os Isr Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Os Isr Type</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsIsrType
	 * @generated
	 */
	EEnum getOsIsrType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.autosar.OsResourceType <em>Os Resource Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Os Resource Type</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsResourceType
	 * @generated
	 */
	EEnum getOsResourceType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.autosar.OsScheduleTableStartType <em>Os Schedule Table Start Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Os Schedule Table Start Type</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsScheduleTableStartType
	 * @generated
	 */
	EEnum getOsScheduleTableStartType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.autosar.OsSpinlockLockMethod <em>Os Spinlock Lock Method</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Os Spinlock Lock Method</em>'.
	 * @see com.inchron.realtime.root.model.autosar.OsSpinlockLockMethod
	 * @generated
	 */
	EEnum getOsSpinlockLockMethod();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	AutosarFactory getAutosarFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.ARSystemImpl <em>AR System</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.ARSystemImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getARSystem()
		 * @generated
		 */
		EClass AR_SYSTEM = eINSTANCE.getARSystem();

		/**
		 * The meta object literal for the '<em><b>Os Config</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AR_SYSTEM__OS_CONFIG = eINSTANCE.getARSystem_OsConfig();

		/**
		 * The meta object literal for the '<em><b>Is Osek</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AR_SYSTEM__IS_OSEK = eINSTANCE.getARSystem_IsOsek();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.ClearEventImpl <em>Clear Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.ClearEventImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getClearEvent()
		 * @generated
		 */
		EClass CLEAR_EVENT = eINSTANCE.getClearEvent();

		/**
		 * The meta object literal for the '<em><b>Events</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CLEAR_EVENT__EVENTS = eINSTANCE.getClearEvent_Events();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.OperationImpl <em>Operation</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.OperationImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOperation()
		 * @generated
		 */
		EClass OPERATION = eINSTANCE.getOperation();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmImpl <em>Os Alarm</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.OsAlarmImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsAlarm()
		 * @generated
		 */
		EClass OS_ALARM = eINSTANCE.getOsAlarm();

		/**
		 * The meta object literal for the '<em><b>Action</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_ALARM__ACTION = eINSTANCE.getOsAlarm_Action();

		/**
		 * The meta object literal for the '<em><b>Autostart App Mode</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_ALARM__AUTOSTART_APP_MODE = eINSTANCE.getOsAlarm_AutostartAppMode();

		/**
		 * The meta object literal for the '<em><b>Autostart Cycle Time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_ALARM__AUTOSTART_CYCLE_TIME = eINSTANCE.getOsAlarm_AutostartCycleTime();

		/**
		 * The meta object literal for the '<em><b>Autostart Alarm Time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_ALARM__AUTOSTART_ALARM_TIME = eINSTANCE.getOsAlarm_AutostartAlarmTime();

		/**
		 * The meta object literal for the '<em><b>Autostart</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_ALARM__AUTOSTART = eINSTANCE.getOsAlarm_Autostart();

		/**
		 * The meta object literal for the '<em><b>Counter</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_ALARM__COUNTER = eINSTANCE.getOsAlarm_Counter();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmActionImpl <em>Os Alarm Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.OsAlarmActionImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsAlarmAction()
		 * @generated
		 */
		EClass OS_ALARM_ACTION = eINSTANCE.getOsAlarmAction();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_ALARM_ACTION__TYPE = eINSTANCE.getOsAlarmAction_Type();

		/**
		 * The meta object literal for the '<em><b>Task</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_ALARM_ACTION__TASK = eINSTANCE.getOsAlarmAction_Task();

		/**
		 * The meta object literal for the '<em><b>Event</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_ALARM_ACTION__EVENT = eINSTANCE.getOsAlarmAction_Event();

		/**
		 * The meta object literal for the '<em><b>Callback</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_ALARM_ACTION__CALLBACK = eINSTANCE.getOsAlarmAction_Callback();

		/**
		 * The meta object literal for the '<em><b>Max Advance</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_ALARM_ACTION__MAX_ADVANCE = eINSTANCE.getOsAlarmAction_MaxAdvance();

		/**
		 * The meta object literal for the '<em><b>Max Retard</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_ALARM_ACTION__MAX_RETARD = eINSTANCE.getOsAlarmAction_MaxRetard();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.OsApplicationImpl <em>Os Application</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.OsApplicationImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsApplication()
		 * @generated
		 */
		EClass OS_APPLICATION = eINSTANCE.getOsApplication();

		/**
		 * The meta object literal for the '<em><b>Alarms</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_APPLICATION__ALARMS = eINSTANCE.getOsApplication_Alarms();

		/**
		 * The meta object literal for the '<em><b>Counters</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_APPLICATION__COUNTERS = eINSTANCE.getOsApplication_Counters();

		/**
		 * The meta object literal for the '<em><b>Cpu Core</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_APPLICATION__CPU_CORE = eINSTANCE.getOsApplication_CpuCore();

		/**
		 * The meta object literal for the '<em><b>Partition</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_APPLICATION__PARTITION = eINSTANCE.getOsApplication_Partition();

		/**
		 * The meta object literal for the '<em><b>Isrs</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_APPLICATION__ISRS = eINSTANCE.getOsApplication_Isrs();

		/**
		 * The meta object literal for the '<em><b>Schedule Tables</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_APPLICATION__SCHEDULE_TABLES = eINSTANCE.getOsApplication_ScheduleTables();

		/**
		 * The meta object literal for the '<em><b>Tasks</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_APPLICATION__TASKS = eINSTANCE.getOsApplication_Tasks();

		/**
		 * The meta object literal for the '<em><b>Is Trusted</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_APPLICATION__IS_TRUSTED = eINSTANCE.getOsApplication_IsTrusted();

		/**
		 * The meta object literal for the '<em><b>Is Trusted With Protection</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_APPLICATION__IS_TRUSTED_WITH_PROTECTION = eINSTANCE.getOsApplication_IsTrustedWithProtection();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.OsConfigImpl <em>Os Config</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.OsConfigImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsConfig()
		 * @generated
		 */
		EClass OS_CONFIG = eINSTANCE.getOsConfig();

		/**
		 * The meta object literal for the '<em><b>Alarms</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_CONFIG__ALARMS = eINSTANCE.getOsConfig_Alarms();

		/**
		 * The meta object literal for the '<em><b>Applications</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_CONFIG__APPLICATIONS = eINSTANCE.getOsConfig_Applications();

		/**
		 * The meta object literal for the '<em><b>Counters</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_CONFIG__COUNTERS = eINSTANCE.getOsConfig_Counters();

		/**
		 * The meta object literal for the '<em><b>Events</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_CONFIG__EVENTS = eINSTANCE.getOsConfig_Events();

		/**
		 * The meta object literal for the '<em><b>Isrs</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_CONFIG__ISRS = eINSTANCE.getOsConfig_Isrs();

		/**
		 * The meta object literal for the '<em><b>Resources</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_CONFIG__RESOURCES = eINSTANCE.getOsConfig_Resources();

		/**
		 * The meta object literal for the '<em><b>Schedule Tables</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_CONFIG__SCHEDULE_TABLES = eINSTANCE.getOsConfig_ScheduleTables();

		/**
		 * The meta object literal for the '<em><b>Spinlocks</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_CONFIG__SPINLOCKS = eINSTANCE.getOsConfig_Spinlocks();

		/**
		 * The meta object literal for the '<em><b>Tasks</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_CONFIG__TASKS = eINSTANCE.getOsConfig_Tasks();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.OsCounterImpl <em>Os Counter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.OsCounterImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsCounter()
		 * @generated
		 */
		EClass OS_COUNTER = eINSTANCE.getOsCounter();

		/**
		 * The meta object literal for the '<em><b>Delay</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_COUNTER__DELAY = eINSTANCE.getOsCounter_Delay();

		/**
		 * The meta object literal for the '<em><b>Granularity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_COUNTER__GRANULARITY = eINSTANCE.getOsCounter_Granularity();

		/**
		 * The meta object literal for the '<em><b>Hardware</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_COUNTER__HARDWARE = eINSTANCE.getOsCounter_Hardware();

		/**
		 * The meta object literal for the '<em><b>Mincycle</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_COUNTER__MINCYCLE = eINSTANCE.getOsCounter_Mincycle();

		/**
		 * The meta object literal for the '<em><b>Range</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_COUNTER__RANGE = eINSTANCE.getOsCounter_Range();

		/**
		 * The meta object literal for the '<em><b>Reference Ticks</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_COUNTER__REFERENCE_TICKS = eINSTANCE.getOsCounter_ReferenceTicks();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.OsEventImpl <em>Os Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.OsEventImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsEvent()
		 * @generated
		 */
		EClass OS_EVENT = eINSTANCE.getOsEvent();

		/**
		 * The meta object literal for the '<em><b>Mask</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_EVENT__MASK = eINSTANCE.getOsEvent_Mask();

		/**
		 * The meta object literal for the '<em><b>Mask Auto</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_EVENT__MASK_AUTO = eINSTANCE.getOsEvent_MaskAuto();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.OsExpiryPointImpl <em>Os Expiry Point</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.OsExpiryPointImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsExpiryPoint()
		 * @generated
		 */
		EClass OS_EXPIRY_POINT = eINSTANCE.getOsExpiryPoint();

		/**
		 * The meta object literal for the '<em><b>Offset</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_EXPIRY_POINT__OFFSET = eINSTANCE.getOsExpiryPoint_Offset();

		/**
		 * The meta object literal for the '<em><b>Actions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_EXPIRY_POINT__ACTIONS = eINSTANCE.getOsExpiryPoint_Actions();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.OsIsrImpl <em>Os Isr</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.OsIsrImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsIsr()
		 * @generated
		 */
		EClass OS_ISR = eINSTANCE.getOsIsr();

		/**
		 * The meta object literal for the '<em><b>Resources</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_ISR__RESOURCES = eINSTANCE.getOsIsr_Resources();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_ISR__TYPE = eINSTANCE.getOsIsr_Type();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.OsResourceImpl <em>Os Resource</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.OsResourceImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsResource()
		 * @generated
		 */
		EClass OS_RESOURCE = eINSTANCE.getOsResource();

		/**
		 * The meta object literal for the '<em><b>Property</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_RESOURCE__PROPERTY = eINSTANCE.getOsResource_Property();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.OsScheduleTableImpl <em>Os Schedule Table</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.OsScheduleTableImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsScheduleTable()
		 * @generated
		 */
		EClass OS_SCHEDULE_TABLE = eINSTANCE.getOsScheduleTable();

		/**
		 * The meta object literal for the '<em><b>Autostart</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_SCHEDULE_TABLE__AUTOSTART = eINSTANCE.getOsScheduleTable_Autostart();

		/**
		 * The meta object literal for the '<em><b>Counter</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_SCHEDULE_TABLE__COUNTER = eINSTANCE.getOsScheduleTable_Counter();

		/**
		 * The meta object literal for the '<em><b>Duration</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_SCHEDULE_TABLE__DURATION = eINSTANCE.getOsScheduleTable_Duration();

		/**
		 * The meta object literal for the '<em><b>Expiry Points</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_SCHEDULE_TABLE__EXPIRY_POINTS = eINSTANCE.getOsScheduleTable_ExpiryPoints();

		/**
		 * The meta object literal for the '<em><b>Repeating</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_SCHEDULE_TABLE__REPEATING = eINSTANCE.getOsScheduleTable_Repeating();

		/**
		 * The meta object literal for the '<em><b>Start Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_SCHEDULE_TABLE__START_TYPE = eINSTANCE.getOsScheduleTable_StartType();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.OsSpinlockImpl <em>Os Spinlock</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.OsSpinlockImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsSpinlock()
		 * @generated
		 */
		EClass OS_SPINLOCK = eINSTANCE.getOsSpinlock();

		/**
		 * The meta object literal for the '<em><b>Method</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OS_SPINLOCK__METHOD = eINSTANCE.getOsSpinlock_Method();

		/**
		 * The meta object literal for the '<em><b>Successor</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_SPINLOCK__SUCCESSOR = eINSTANCE.getOsSpinlock_Successor();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.OsTaskImpl <em>Os Task</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.OsTaskImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsTask()
		 * @generated
		 */
		EClass OS_TASK = eINSTANCE.getOsTask();

		/**
		 * The meta object literal for the '<em><b>Events</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_TASK__EVENTS = eINSTANCE.getOsTask_Events();

		/**
		 * The meta object literal for the '<em><b>Resources</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OS_TASK__RESOURCES = eINSTANCE.getOsTask_Resources();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.ResumeOSInterruptsImpl <em>Resume OS Interrupts</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.ResumeOSInterruptsImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getResumeOSInterrupts()
		 * @generated
		 */
		EClass RESUME_OS_INTERRUPTS = eINSTANCE.getResumeOSInterrupts();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.RunnableImpl <em>Runnable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.RunnableImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getRunnable()
		 * @generated
		 */
		EClass RUNNABLE = eINSTANCE.getRunnable();

		/**
		 * The meta object literal for the '<em><b>Can Be Invoked Concurrently</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RUNNABLE__CAN_BE_INVOKED_CONCURRENTLY = eINSTANCE.getRunnable_CanBeInvokedConcurrently();

		/**
		 * The meta object literal for the '<em><b>Disabled In Mode</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RUNNABLE__DISABLED_IN_MODE = eINSTANCE.getRunnable_DisabledInMode();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.ServerCallImpl <em>Server Call</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.ServerCallImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getServerCall()
		 * @generated
		 */
		EClass SERVER_CALL = eINSTANCE.getServerCall();

		/**
		 * The meta object literal for the '<em><b>Invoked Operation</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SERVER_CALL__INVOKED_OPERATION = eINSTANCE.getServerCall_InvokedOperation();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.SuspendOSInterruptsImpl <em>Suspend OS Interrupts</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.SuspendOSInterruptsImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getSuspendOSInterrupts()
		 * @generated
		 */
		EClass SUSPEND_OS_INTERRUPTS = eINSTANCE.getSuspendOSInterrupts();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.impl.SwComponentImpl <em>Sw Component</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.impl.SwComponentImpl
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getSwComponent()
		 * @generated
		 */
		EClass SW_COMPONENT = eINSTANCE.getSwComponent();

		/**
		 * The meta object literal for the '<em><b>Operations</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SW_COMPONENT__OPERATIONS = eINSTANCE.getSwComponent_Operations();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.OsAlarmActionType <em>Os Alarm Action Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.OsAlarmActionType
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsAlarmActionType()
		 * @generated
		 */
		EEnum OS_ALARM_ACTION_TYPE = eINSTANCE.getOsAlarmActionType();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.OsIsrType <em>Os Isr Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.OsIsrType
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsIsrType()
		 * @generated
		 */
		EEnum OS_ISR_TYPE = eINSTANCE.getOsIsrType();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.OsResourceType <em>Os Resource Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.OsResourceType
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsResourceType()
		 * @generated
		 */
		EEnum OS_RESOURCE_TYPE = eINSTANCE.getOsResourceType();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.OsScheduleTableStartType <em>Os Schedule Table Start Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.OsScheduleTableStartType
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsScheduleTableStartType()
		 * @generated
		 */
		EEnum OS_SCHEDULE_TABLE_START_TYPE = eINSTANCE.getOsScheduleTableStartType();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.autosar.OsSpinlockLockMethod <em>Os Spinlock Lock Method</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.autosar.OsSpinlockLockMethod
		 * @see com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl#getOsSpinlockLockMethod()
		 * @generated
		 */
		EEnum OS_SPINLOCK_LOCK_METHOD = eINSTANCE.getOsSpinlockLockMethod();

	}

} //AutosarPackage
