/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Os Alarm Action Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarmActionType()
 * @model
 * @generated
 */
public enum OsAlarmActionType implements Enumerator {
	/**
	 * The '<em><b>Activate Task</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ACTIVATE_TASK_VALUE
	 * @generated
	 * @ordered
	 */
	ACTIVATE_TASK(0, "ActivateTask", "ActivateTask"),

	/**
	 * The '<em><b>Set Event</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SET_EVENT_VALUE
	 * @generated
	 * @ordered
	 */
	SET_EVENT(1, "SetEvent", "SetEvent"),

	/**
	 * The '<em><b>Callback</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CALLBACK_VALUE
	 * @generated
	 * @ordered
	 */
	CALLBACK(2, "Callback", "Callback"),

	/**
	 * The '<em><b>Adjust Expiry Point</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ADJUST_EXPIRY_POINT_VALUE
	 * @generated
	 * @ordered
	 */
	ADJUST_EXPIRY_POINT(3, "AdjustExpiryPoint", "AdjustExpiryPoint");

	/**
	 * The '<em><b>Activate Task</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Activate Task</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ACTIVATE_TASK
	 * @model name="ActivateTask"
	 * @generated
	 * @ordered
	 */
	public static final int ACTIVATE_TASK_VALUE = 0;

	/**
	 * The '<em><b>Set Event</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Set Event</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SET_EVENT
	 * @model name="SetEvent"
	 * @generated
	 * @ordered
	 */
	public static final int SET_EVENT_VALUE = 1;

	/**
	 * The '<em><b>Callback</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Callback</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CALLBACK
	 * @model name="Callback"
	 * @generated
	 * @ordered
	 */
	public static final int CALLBACK_VALUE = 2;

	/**
	 * The '<em><b>Adjust Expiry Point</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Adjust Expiry Point</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ADJUST_EXPIRY_POINT
	 * @model name="AdjustExpiryPoint"
	 * @generated
	 * @ordered
	 */
	public static final int ADJUST_EXPIRY_POINT_VALUE = 3;

	/**
	 * An array of all the '<em><b>Os Alarm Action Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final OsAlarmActionType[] VALUES_ARRAY =
		new OsAlarmActionType[] {
			ACTIVATE_TASK,
			SET_EVENT,
			CALLBACK,
			ADJUST_EXPIRY_POINT,
		};

	/**
	 * A public read-only list of all the '<em><b>Os Alarm Action Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<OsAlarmActionType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Os Alarm Action Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static OsAlarmActionType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			OsAlarmActionType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Os Alarm Action Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static OsAlarmActionType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			OsAlarmActionType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Os Alarm Action Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static OsAlarmActionType get(int value) {
		switch (value) {
			case ACTIVATE_TASK_VALUE: return ACTIVATE_TASK;
			case SET_EVENT_VALUE: return SET_EVENT;
			case CALLBACK_VALUE: return CALLBACK;
			case ADJUST_EXPIRY_POINT_VALUE: return ADJUST_EXPIRY_POINT;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private OsAlarmActionType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //OsAlarmActionType
