/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import com.inchron.realtime.root.model.ModelObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Os Expiry Point</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsExpiryPoint#getOffset <em>Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsExpiryPoint#getActions <em>Actions</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsExpiryPoint()
 * @model
 * @generated
 */
public interface OsExpiryPoint extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Offset</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Offset</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Offset</em>' attribute.
	 * @see #setOffset(long)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsExpiryPoint_Offset()
	 * @model default="0" required="true" ordered="false"
	 * @generated
	 */
	long getOffset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsExpiryPoint#getOffset <em>Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Offset</em>' attribute.
	 * @see #getOffset()
	 * @generated
	 */
	void setOffset(long value);

	/**
	 * Returns the value of the '<em><b>Actions</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsAlarmAction}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Actions</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Actions</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsExpiryPoint_Actions()
	 * @model containment="true"
	 * @generated
	 */
	EList<OsAlarmAction> getActions();

} // OsExpiryPoint
