/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import com.inchron.realtime.root.model.Function;
import com.inchron.realtime.root.model.Mode;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Runnable</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.Runnable#isCanBeInvokedConcurrently <em>Can Be Invoked Concurrently</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.Runnable#getDisabledInMode <em>Disabled In Mode</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getRunnable()
 * @model
 * @generated
 */
public interface Runnable extends Function {
	/**
	 * Returns the value of the '<em><b>Can Be Invoked Concurrently</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Can Be Invoked Concurrently</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Can Be Invoked Concurrently</em>' attribute.
	 * @see #setCanBeInvokedConcurrently(boolean)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getRunnable_CanBeInvokedConcurrently()
	 * @model default="false"
	 * @generated
	 */
	boolean isCanBeInvokedConcurrently();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.Runnable#isCanBeInvokedConcurrently <em>Can Be Invoked Concurrently</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Can Be Invoked Concurrently</em>' attribute.
	 * @see #isCanBeInvokedConcurrently()
	 * @generated
	 */
	void setCanBeInvokedConcurrently(boolean value);

	/**
	 * Returns the value of the '<em><b>Disabled In Mode</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Disabled In Mode</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disabled In Mode</em>' reference.
	 * @see #setDisabledInMode(Mode)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getRunnable_DisabledInMode()
	 * @model
	 * @generated
	 */
	Mode getDisabledInMode();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.Runnable#getDisabledInMode <em>Disabled In Mode</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disabled In Mode</em>' reference.
	 * @see #getDisabledInMode()
	 * @generated
	 */
	void setDisabledInMode(Mode value);

} // Runnable
