/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar.impl;

import com.inchron.realtime.root.model.autosar.ARSystem;
import com.inchron.realtime.root.model.autosar.AutosarPackage;
import com.inchron.realtime.root.model.autosar.OsConfig;

import com.inchron.realtime.root.model.impl.SystemImpl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>AR System</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.ARSystemImpl#getOsConfig <em>Os Config</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.ARSystemImpl#isIsOsek <em>Is Osek</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ARSystemImpl extends SystemImpl implements ARSystem {
	/**
	 * The cached value of the '{@link #getOsConfig() <em>Os Config</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOsConfig()
	 * @generated
	 * @ordered
	 */
	protected OsConfig osConfig;

	/**
	 * The default value of the '{@link #isIsOsek() <em>Is Osek</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsOsek()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_OSEK_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsOsek() <em>Is Osek</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsOsek()
	 * @generated
	 * @ordered
	 */
	protected boolean isOsek = IS_OSEK_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ARSystemImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AutosarPackage.Literals.AR_SYSTEM;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsConfig getOsConfig() {
		return osConfig;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetOsConfig(OsConfig newOsConfig, NotificationChain msgs) {
		OsConfig oldOsConfig = osConfig;
		osConfig = newOsConfig;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AutosarPackage.AR_SYSTEM__OS_CONFIG, oldOsConfig, newOsConfig);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOsConfig(OsConfig newOsConfig) {
		if (newOsConfig != osConfig) {
			NotificationChain msgs = null;
			if (osConfig != null)
				msgs = ((InternalEObject)osConfig).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - AutosarPackage.AR_SYSTEM__OS_CONFIG, null, msgs);
			if (newOsConfig != null)
				msgs = ((InternalEObject)newOsConfig).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - AutosarPackage.AR_SYSTEM__OS_CONFIG, null, msgs);
			msgs = basicSetOsConfig(newOsConfig, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.AR_SYSTEM__OS_CONFIG, newOsConfig, newOsConfig));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsOsek() {
		return isOsek;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsOsek(boolean newIsOsek) {
		boolean oldIsOsek = isOsek;
		isOsek = newIsOsek;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.AR_SYSTEM__IS_OSEK, oldIsOsek, isOsek));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AutosarPackage.AR_SYSTEM__OS_CONFIG:
				return basicSetOsConfig(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AutosarPackage.AR_SYSTEM__OS_CONFIG:
				return getOsConfig();
			case AutosarPackage.AR_SYSTEM__IS_OSEK:
				return isIsOsek();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AutosarPackage.AR_SYSTEM__OS_CONFIG:
				setOsConfig((OsConfig)newValue);
				return;
			case AutosarPackage.AR_SYSTEM__IS_OSEK:
				setIsOsek((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AutosarPackage.AR_SYSTEM__OS_CONFIG:
				setOsConfig((OsConfig)null);
				return;
			case AutosarPackage.AR_SYSTEM__IS_OSEK:
				setIsOsek(IS_OSEK_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AutosarPackage.AR_SYSTEM__OS_CONFIG:
				return osConfig != null;
			case AutosarPackage.AR_SYSTEM__IS_OSEK:
				return isOsek != IS_OSEK_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (isOsek: ");
		result.append(isOsek);
		result.append(')');
		return result.toString();
	}

} //ARSystemImpl
