/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar.impl;

import com.inchron.realtime.root.model.SourceFunction;

import com.inchron.realtime.root.model.autosar.AutosarPackage;
import com.inchron.realtime.root.model.autosar.OsAlarmAction;
import com.inchron.realtime.root.model.autosar.OsAlarmActionType;
import com.inchron.realtime.root.model.autosar.OsEvent;
import com.inchron.realtime.root.model.autosar.OsTask;

import com.inchron.realtime.root.model.impl.ModelObjectImpl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Os Alarm Action</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmActionImpl#getType <em>Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmActionImpl#getTask <em>Task</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmActionImpl#getEvent <em>Event</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmActionImpl#getCallback <em>Callback</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmActionImpl#getMaxAdvance <em>Max Advance</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmActionImpl#getMaxRetard <em>Max Retard</em>}</li>
 * </ul>
 *
 * @generated
 */
public class OsAlarmActionImpl extends ModelObjectImpl implements OsAlarmAction {
	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final OsAlarmActionType TYPE_EDEFAULT = OsAlarmActionType.ACTIVATE_TASK;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected OsAlarmActionType type = TYPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getTask() <em>Task</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTask()
	 * @generated
	 * @ordered
	 */
	protected OsTask task;

	/**
	 * The cached value of the '{@link #getEvent() <em>Event</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEvent()
	 * @generated
	 * @ordered
	 */
	protected OsEvent event;

	/**
	 * The cached value of the '{@link #getCallback() <em>Callback</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCallback()
	 * @generated
	 * @ordered
	 */
	protected SourceFunction callback;

	/**
	 * The default value of the '{@link #getMaxAdvance() <em>Max Advance</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxAdvance()
	 * @generated
	 * @ordered
	 */
	protected static final long MAX_ADVANCE_EDEFAULT = 1L;

	/**
	 * The cached value of the '{@link #getMaxAdvance() <em>Max Advance</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxAdvance()
	 * @generated
	 * @ordered
	 */
	protected long maxAdvance = MAX_ADVANCE_EDEFAULT;

	/**
	 * The default value of the '{@link #getMaxRetard() <em>Max Retard</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxRetard()
	 * @generated
	 * @ordered
	 */
	protected static final long MAX_RETARD_EDEFAULT = 1L;

	/**
	 * The cached value of the '{@link #getMaxRetard() <em>Max Retard</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxRetard()
	 * @generated
	 * @ordered
	 */
	protected long maxRetard = MAX_RETARD_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OsAlarmActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AutosarPackage.Literals.OS_ALARM_ACTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsAlarmActionType getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(OsAlarmActionType newType) {
		OsAlarmActionType oldType = type;
		type = newType == null ? TYPE_EDEFAULT : newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_ALARM_ACTION__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsTask getTask() {
		if (task != null && task.eIsProxy()) {
			InternalEObject oldTask = (InternalEObject)task;
			task = (OsTask)eResolveProxy(oldTask);
			if (task != oldTask) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AutosarPackage.OS_ALARM_ACTION__TASK, oldTask, task));
			}
		}
		return task;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsTask basicGetTask() {
		return task;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTask(OsTask newTask) {
		OsTask oldTask = task;
		task = newTask;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_ALARM_ACTION__TASK, oldTask, task));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsEvent getEvent() {
		if (event != null && event.eIsProxy()) {
			InternalEObject oldEvent = (InternalEObject)event;
			event = (OsEvent)eResolveProxy(oldEvent);
			if (event != oldEvent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AutosarPackage.OS_ALARM_ACTION__EVENT, oldEvent, event));
			}
		}
		return event;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsEvent basicGetEvent() {
		return event;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEvent(OsEvent newEvent) {
		OsEvent oldEvent = event;
		event = newEvent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_ALARM_ACTION__EVENT, oldEvent, event));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SourceFunction getCallback() {
		if (callback != null && callback.eIsProxy()) {
			InternalEObject oldCallback = (InternalEObject)callback;
			callback = (SourceFunction)eResolveProxy(oldCallback);
			if (callback != oldCallback) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AutosarPackage.OS_ALARM_ACTION__CALLBACK, oldCallback, callback));
			}
		}
		return callback;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SourceFunction basicGetCallback() {
		return callback;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCallback(SourceFunction newCallback) {
		SourceFunction oldCallback = callback;
		callback = newCallback;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_ALARM_ACTION__CALLBACK, oldCallback, callback));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getMaxAdvance() {
		return maxAdvance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaxAdvance(long newMaxAdvance) {
		long oldMaxAdvance = maxAdvance;
		maxAdvance = newMaxAdvance;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_ALARM_ACTION__MAX_ADVANCE, oldMaxAdvance, maxAdvance));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getMaxRetard() {
		return maxRetard;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaxRetard(long newMaxRetard) {
		long oldMaxRetard = maxRetard;
		maxRetard = newMaxRetard;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_ALARM_ACTION__MAX_RETARD, oldMaxRetard, maxRetard));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AutosarPackage.OS_ALARM_ACTION__TYPE:
				return getType();
			case AutosarPackage.OS_ALARM_ACTION__TASK:
				if (resolve) return getTask();
				return basicGetTask();
			case AutosarPackage.OS_ALARM_ACTION__EVENT:
				if (resolve) return getEvent();
				return basicGetEvent();
			case AutosarPackage.OS_ALARM_ACTION__CALLBACK:
				if (resolve) return getCallback();
				return basicGetCallback();
			case AutosarPackage.OS_ALARM_ACTION__MAX_ADVANCE:
				return getMaxAdvance();
			case AutosarPackage.OS_ALARM_ACTION__MAX_RETARD:
				return getMaxRetard();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AutosarPackage.OS_ALARM_ACTION__TYPE:
				setType((OsAlarmActionType)newValue);
				return;
			case AutosarPackage.OS_ALARM_ACTION__TASK:
				setTask((OsTask)newValue);
				return;
			case AutosarPackage.OS_ALARM_ACTION__EVENT:
				setEvent((OsEvent)newValue);
				return;
			case AutosarPackage.OS_ALARM_ACTION__CALLBACK:
				setCallback((SourceFunction)newValue);
				return;
			case AutosarPackage.OS_ALARM_ACTION__MAX_ADVANCE:
				setMaxAdvance((Long)newValue);
				return;
			case AutosarPackage.OS_ALARM_ACTION__MAX_RETARD:
				setMaxRetard((Long)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AutosarPackage.OS_ALARM_ACTION__TYPE:
				setType(TYPE_EDEFAULT);
				return;
			case AutosarPackage.OS_ALARM_ACTION__TASK:
				setTask((OsTask)null);
				return;
			case AutosarPackage.OS_ALARM_ACTION__EVENT:
				setEvent((OsEvent)null);
				return;
			case AutosarPackage.OS_ALARM_ACTION__CALLBACK:
				setCallback((SourceFunction)null);
				return;
			case AutosarPackage.OS_ALARM_ACTION__MAX_ADVANCE:
				setMaxAdvance(MAX_ADVANCE_EDEFAULT);
				return;
			case AutosarPackage.OS_ALARM_ACTION__MAX_RETARD:
				setMaxRetard(MAX_RETARD_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AutosarPackage.OS_ALARM_ACTION__TYPE:
				return type != TYPE_EDEFAULT;
			case AutosarPackage.OS_ALARM_ACTION__TASK:
				return task != null;
			case AutosarPackage.OS_ALARM_ACTION__EVENT:
				return event != null;
			case AutosarPackage.OS_ALARM_ACTION__CALLBACK:
				return callback != null;
			case AutosarPackage.OS_ALARM_ACTION__MAX_ADVANCE:
				return maxAdvance != MAX_ADVANCE_EDEFAULT;
			case AutosarPackage.OS_ALARM_ACTION__MAX_RETARD:
				return maxRetard != MAX_RETARD_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (type: ");
		result.append(type);
		result.append(", maxAdvance: ");
		result.append(maxAdvance);
		result.append(", maxRetard: ");
		result.append(maxRetard);
		result.append(')');
		return result.toString();
	}

} //OsAlarmActionImpl
