/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Integer Attributes</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.IntegerAttributes#getMax <em>Max</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.IntegerAttributes#getMin <em>Min</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.IntegerAttributes#getQuantity <em>Quantity</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getIntegerAttributes()
 * @model abstract="true"
 * @generated
 */
public interface IntegerAttributes extends EObject {
	/**
	 * Returns the value of the '<em><b>Max</b></em>' attribute.
	 * The default value is <code>"2147483647"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max</em>' attribute.
	 * @see #setMax(int)
	 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getIntegerAttributes_Max()
	 * @model default="2147483647"
	 * @generated
	 */
	int getMax();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.IntegerAttributes#getMax <em>Max</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max</em>' attribute.
	 * @see #getMax()
	 * @generated
	 */
	void setMax(int value);

	/**
	 * Returns the value of the '<em><b>Min</b></em>' attribute.
	 * The default value is <code>"-2147483648"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Min</em>' attribute.
	 * @see #setMin(int)
	 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getIntegerAttributes_Min()
	 * @model default="-2147483648"
	 * @generated
	 */
	int getMin();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.IntegerAttributes#getMin <em>Min</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Min</em>' attribute.
	 * @see #getMin()
	 * @generated
	 */
	void setMin(int value);

	/**
	 * Returns the value of the '<em><b>Quantity</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Quantity</em>' attribute.
	 * @see #setQuantity(String)
	 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getIntegerAttributes_Quantity()
	 * @model default=""
	 * @generated
	 */
	String getQuantity();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.IntegerAttributes#getQuantity <em>Quantity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Quantity</em>' attribute.
	 * @see #getQuantity()
	 * @generated
	 */
	void setQuantity(String value);

} // IntegerAttributes
