/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi;

import com.inchron.realtime.root.model.fmi.unit.DisplayUnit;
import com.inchron.realtime.root.model.fmi.unit.Unit;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Real Attributes</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.RealAttributes#getDisplayUnit <em>Display Unit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.RealAttributes#getMax <em>Max</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.RealAttributes#getMin <em>Min</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.RealAttributes#getQuantity <em>Quantity</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.RealAttributes#isRelativeQuantity <em>Relative Quantity</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.RealAttributes#getUnit <em>Unit</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getRealAttributes()
 * @model abstract="true"
 * @generated
 */
public interface RealAttributes extends EObject {
	/**
	 * Returns the value of the '<em><b>Display Unit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Display Unit</em>' reference.
	 * @see #setDisplayUnit(DisplayUnit)
	 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getRealAttributes_DisplayUnit()
	 * @model
	 * @generated
	 */
	DisplayUnit getDisplayUnit();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.RealAttributes#getDisplayUnit <em>Display Unit</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Display Unit</em>' reference.
	 * @see #getDisplayUnit()
	 * @generated
	 */
	void setDisplayUnit(DisplayUnit value);

	/**
	 * Returns the value of the '<em><b>Max</b></em>' attribute.
	 * The default value is <code>"1.7976931348623157e+308"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max</em>' attribute.
	 * @see #setMax(double)
	 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getRealAttributes_Max()
	 * @model default="1.7976931348623157e+308"
	 * @generated
	 */
	double getMax();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.RealAttributes#getMax <em>Max</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max</em>' attribute.
	 * @see #getMax()
	 * @generated
	 */
	void setMax(double value);

	/**
	 * Returns the value of the '<em><b>Min</b></em>' attribute.
	 * The default value is <code>"-1.7976931348623157e+308"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Min</em>' attribute.
	 * @see #setMin(double)
	 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getRealAttributes_Min()
	 * @model default="-1.7976931348623157e+308"
	 * @generated
	 */
	double getMin();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.RealAttributes#getMin <em>Min</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Min</em>' attribute.
	 * @see #getMin()
	 * @generated
	 */
	void setMin(double value);

	/**
	 * Returns the value of the '<em><b>Quantity</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Quantity</em>' attribute.
	 * @see #setQuantity(String)
	 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getRealAttributes_Quantity()
	 * @model default=""
	 * @generated
	 */
	String getQuantity();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.RealAttributes#getQuantity <em>Quantity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Quantity</em>' attribute.
	 * @see #getQuantity()
	 * @generated
	 */
	void setQuantity(String value);

	/**
	 * Returns the value of the '<em><b>Relative Quantity</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Relative Quantity</em>' attribute.
	 * @see #setRelativeQuantity(boolean)
	 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getRealAttributes_RelativeQuantity()
	 * @model default="false"
	 * @generated
	 */
	boolean isRelativeQuantity();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.RealAttributes#isRelativeQuantity <em>Relative Quantity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Relative Quantity</em>' attribute.
	 * @see #isRelativeQuantity()
	 * @generated
	 */
	void setRelativeQuantity(boolean value);

	/**
	 * Returns the value of the '<em><b>Unit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Unit</em>' reference.
	 * @see #setUnit(Unit)
	 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getRealAttributes_Unit()
	 * @model
	 * @generated
	 */
	Unit getUnit();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.RealAttributes#getUnit <em>Unit</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Unit</em>' reference.
	 * @see #getUnit()
	 * @generated
	 */
	void setUnit(Unit value);

} // RealAttributes
