/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.variable;

import com.inchron.realtime.root.model.fmi.RealAttributes;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Real</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.Real#getDeclaredType <em>Declared Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.Real#getStart <em>Start</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getReal()
 * @model
 * @generated
 */
public interface Real extends ScalarVariable, RealAttributes {
	/**
	 * Returns the value of the '<em><b>Declared Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Declared Type</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Declared Type</em>' reference.
	 * @see #setDeclaredType(com.inchron.realtime.root.model.fmi.type.Real)
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getReal_DeclaredType()
	 * @model
	 * @generated
	 */
	com.inchron.realtime.root.model.fmi.type.Real getDeclaredType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.variable.Real#getDeclaredType <em>Declared Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Declared Type</em>' reference.
	 * @see #getDeclaredType()
	 * @generated
	 */
	void setDeclaredType(com.inchron.realtime.root.model.fmi.type.Real value);

	/**
	 * Returns the value of the '<em><b>Start</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start</em>' attribute.
	 * @see #setStart(double)
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getReal_Start()
	 * @model default="0"
	 * @generated
	 */
	double getStart();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.variable.Real#getStart <em>Start</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start</em>' attribute.
	 * @see #getStart()
	 * @generated
	 */
	void setStart(double value);

} // Real
