/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.Event;
import com.inchron.realtime.root.model.EventConjunctionOperatorType;
import com.inchron.realtime.root.model.Function;
import com.inchron.realtime.root.model.FunctionCall;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.SetGuard;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Function Call</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.FunctionCallImpl#getFunction <em>Function</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.FunctionCallImpl#getGuards <em>Guards</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.FunctionCallImpl#getEvents <em>Events</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.FunctionCallImpl#getEventConjunctionOperator <em>Event Conjunction Operator</em>}</li>
 * </ul>
 *
 * @generated
 */
public class FunctionCallImpl extends CallSequenceItemImpl implements FunctionCall {
	/**
	 * The cached value of the '{@link #getFunction() <em>Function</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFunction()
	 * @generated
	 * @ordered
	 */
	protected Function function;

	/**
	 * The cached value of the '{@link #getGuards() <em>Guards</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGuards()
	 * @generated
	 * @ordered
	 */
	protected EList<SetGuard> guards;

	/**
	 * The cached value of the '{@link #getEvents() <em>Events</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEvents()
	 * @generated
	 * @ordered
	 */
	protected EList<Event> events;

	/**
	 * The default value of the '{@link #getEventConjunctionOperator() <em>Event Conjunction Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEventConjunctionOperator()
	 * @generated
	 * @ordered
	 */
	protected static final EventConjunctionOperatorType EVENT_CONJUNCTION_OPERATOR_EDEFAULT = EventConjunctionOperatorType.OR;

	/**
	 * The cached value of the '{@link #getEventConjunctionOperator() <em>Event Conjunction Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEventConjunctionOperator()
	 * @generated
	 * @ordered
	 */
	protected EventConjunctionOperatorType eventConjunctionOperator = EVENT_CONJUNCTION_OPERATOR_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FunctionCallImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getFunctionCall();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Function getFunction() {
		if (function != null && function.eIsProxy()) {
			InternalEObject oldFunction = (InternalEObject)function;
			function = (Function)eResolveProxy(oldFunction);
			if (function != oldFunction) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.FUNCTION_CALL__FUNCTION, oldFunction, function));
			}
		}
		return function;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Function basicGetFunction() {
		return function;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFunction(Function newFunction) {
		Function oldFunction = function;
		function = newFunction;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.FUNCTION_CALL__FUNCTION, oldFunction, function));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SetGuard> getGuards() {
		if (guards == null) {
			guards = new EObjectWithInverseResolvingEList<SetGuard>(SetGuard.class, this, ModelPackage.FUNCTION_CALL__GUARDS, ModelPackage.SET_GUARD__FUNCTION_CALL);
		}
		return guards;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Event> getEvents() {
		if (events == null) {
			events = new EObjectResolvingEList<Event>(Event.class, this, ModelPackage.FUNCTION_CALL__EVENTS);
		}
		return events;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventConjunctionOperatorType getEventConjunctionOperator() {
		return eventConjunctionOperator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEventConjunctionOperator(EventConjunctionOperatorType newEventConjunctionOperator) {
		EventConjunctionOperatorType oldEventConjunctionOperator = eventConjunctionOperator;
		eventConjunctionOperator = newEventConjunctionOperator == null ? EVENT_CONJUNCTION_OPERATOR_EDEFAULT : newEventConjunctionOperator;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.FUNCTION_CALL__EVENT_CONJUNCTION_OPERATOR, oldEventConjunctionOperator, eventConjunctionOperator));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.FUNCTION_CALL__GUARDS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getGuards()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.FUNCTION_CALL__GUARDS:
				return ((InternalEList<?>)getGuards()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.FUNCTION_CALL__FUNCTION:
				if (resolve) return getFunction();
				return basicGetFunction();
			case ModelPackage.FUNCTION_CALL__GUARDS:
				return getGuards();
			case ModelPackage.FUNCTION_CALL__EVENTS:
				return getEvents();
			case ModelPackage.FUNCTION_CALL__EVENT_CONJUNCTION_OPERATOR:
				return getEventConjunctionOperator();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.FUNCTION_CALL__FUNCTION:
				setFunction((Function)newValue);
				return;
			case ModelPackage.FUNCTION_CALL__GUARDS:
				getGuards().clear();
				getGuards().addAll((Collection<? extends SetGuard>)newValue);
				return;
			case ModelPackage.FUNCTION_CALL__EVENTS:
				getEvents().clear();
				getEvents().addAll((Collection<? extends Event>)newValue);
				return;
			case ModelPackage.FUNCTION_CALL__EVENT_CONJUNCTION_OPERATOR:
				setEventConjunctionOperator((EventConjunctionOperatorType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.FUNCTION_CALL__FUNCTION:
				setFunction((Function)null);
				return;
			case ModelPackage.FUNCTION_CALL__GUARDS:
				getGuards().clear();
				return;
			case ModelPackage.FUNCTION_CALL__EVENTS:
				getEvents().clear();
				return;
			case ModelPackage.FUNCTION_CALL__EVENT_CONJUNCTION_OPERATOR:
				setEventConjunctionOperator(EVENT_CONJUNCTION_OPERATOR_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.FUNCTION_CALL__FUNCTION:
				return function != null;
			case ModelPackage.FUNCTION_CALL__GUARDS:
				return guards != null && !guards.isEmpty();
			case ModelPackage.FUNCTION_CALL__EVENTS:
				return events != null && !events.isEmpty();
			case ModelPackage.FUNCTION_CALL__EVENT_CONJUNCTION_OPERATOR:
				return eventConjunctionOperator != EVENT_CONJUNCTION_OPERATOR_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (eventConjunctionOperator: ");
		result.append(eventConjunctionOperator);
		result.append(')');
		return result.toString();
	}

} //FunctionCallImpl
