/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.HyperVisorSystemSchedulable;
import com.inchron.realtime.root.model.ModelPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hyper Visor System Schedulable</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.HyperVisorSystemSchedulableImpl#getVirtualSystem <em>Virtual System</em>}</li>
 * </ul>
 *
 * @generated
 */
public class HyperVisorSystemSchedulableImpl extends SchedulableImpl implements HyperVisorSystemSchedulable {
	/**
	 * The cached value of the '{@link #getVirtualSystem() <em>Virtual System</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVirtualSystem()
	 * @generated
	 * @ordered
	 */
	protected com.inchron.realtime.root.model.System virtualSystem;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HyperVisorSystemSchedulableImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getHyperVisorSystemSchedulable();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.System getVirtualSystem() {
		if (virtualSystem != null && virtualSystem.eIsProxy()) {
			InternalEObject oldVirtualSystem = (InternalEObject)virtualSystem;
			virtualSystem = (com.inchron.realtime.root.model.System)eResolveProxy(oldVirtualSystem);
			if (virtualSystem != oldVirtualSystem) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.HYPER_VISOR_SYSTEM_SCHEDULABLE__VIRTUAL_SYSTEM, oldVirtualSystem, virtualSystem));
			}
		}
		return virtualSystem;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.System basicGetVirtualSystem() {
		return virtualSystem;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setVirtualSystem(com.inchron.realtime.root.model.System newVirtualSystem) {
		com.inchron.realtime.root.model.System oldVirtualSystem = virtualSystem;
		virtualSystem = newVirtualSystem;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.HYPER_VISOR_SYSTEM_SCHEDULABLE__VIRTUAL_SYSTEM, oldVirtualSystem, virtualSystem));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.HYPER_VISOR_SYSTEM_SCHEDULABLE__VIRTUAL_SYSTEM:
				if (resolve) return getVirtualSystem();
				return basicGetVirtualSystem();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.HYPER_VISOR_SYSTEM_SCHEDULABLE__VIRTUAL_SYSTEM:
				setVirtualSystem((com.inchron.realtime.root.model.System)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.HYPER_VISOR_SYSTEM_SCHEDULABLE__VIRTUAL_SYSTEM:
				setVirtualSystem((com.inchron.realtime.root.model.System)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.HYPER_VISOR_SYSTEM_SCHEDULABLE__VIRTUAL_SYSTEM:
				return virtualSystem != null;
		}
		return super.eIsSet(featureID);
	}

} //HyperVisorSystemSchedulableImpl
