/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.Event;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.RtosConfig;
import com.inchron.realtime.root.model.Schedulable;
import com.inchron.realtime.root.model.Semaphore;
import com.inchron.realtime.root.model.Spinlock;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Rtos Config</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosConfigImpl#getSchedulables <em>Schedulables</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosConfigImpl#getSemaphores <em>Semaphores</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosConfigImpl#getSpinlocks <em>Spinlocks</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosConfigImpl#getEvents <em>Events</em>}</li>
 * </ul>
 *
 * @generated
 */
public class RtosConfigImpl extends ModelObjectImpl implements RtosConfig {
	/**
	 * The cached value of the '{@link #getSchedulables() <em>Schedulables</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSchedulables()
	 * @generated
	 * @ordered
	 */
	protected EList<Schedulable> schedulables;

	/**
	 * The cached value of the '{@link #getSemaphores() <em>Semaphores</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSemaphores()
	 * @generated
	 * @ordered
	 */
	protected EList<Semaphore> semaphores;

	/**
	 * The cached value of the '{@link #getSpinlocks() <em>Spinlocks</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpinlocks()
	 * @generated
	 * @ordered
	 */
	protected EList<Spinlock> spinlocks;

	/**
	 * The cached value of the '{@link #getEvents() <em>Events</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEvents()
	 * @generated
	 * @ordered
	 */
	protected EList<Event> events;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RtosConfigImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getRtosConfig();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Schedulable> getSchedulables() {
		if (schedulables == null) {
			schedulables = new EObjectContainmentEList<Schedulable>(Schedulable.class, this, ModelPackage.RTOS_CONFIG__SCHEDULABLES);
		}
		return schedulables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Semaphore> getSemaphores() {
		if (semaphores == null) {
			semaphores = new EObjectContainmentEList<Semaphore>(Semaphore.class, this, ModelPackage.RTOS_CONFIG__SEMAPHORES);
		}
		return semaphores;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Spinlock> getSpinlocks() {
		if (spinlocks == null) {
			spinlocks = new EObjectContainmentEList<Spinlock>(Spinlock.class, this, ModelPackage.RTOS_CONFIG__SPINLOCKS);
		}
		return spinlocks;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Event> getEvents() {
		if (events == null) {
			events = new EObjectContainmentEList<Event>(Event.class, this, ModelPackage.RTOS_CONFIG__EVENTS);
		}
		return events;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.RTOS_CONFIG__SCHEDULABLES:
				return ((InternalEList<?>)getSchedulables()).basicRemove(otherEnd, msgs);
			case ModelPackage.RTOS_CONFIG__SEMAPHORES:
				return ((InternalEList<?>)getSemaphores()).basicRemove(otherEnd, msgs);
			case ModelPackage.RTOS_CONFIG__SPINLOCKS:
				return ((InternalEList<?>)getSpinlocks()).basicRemove(otherEnd, msgs);
			case ModelPackage.RTOS_CONFIG__EVENTS:
				return ((InternalEList<?>)getEvents()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.RTOS_CONFIG__SCHEDULABLES:
				return getSchedulables();
			case ModelPackage.RTOS_CONFIG__SEMAPHORES:
				return getSemaphores();
			case ModelPackage.RTOS_CONFIG__SPINLOCKS:
				return getSpinlocks();
			case ModelPackage.RTOS_CONFIG__EVENTS:
				return getEvents();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.RTOS_CONFIG__SCHEDULABLES:
				getSchedulables().clear();
				getSchedulables().addAll((Collection<? extends Schedulable>)newValue);
				return;
			case ModelPackage.RTOS_CONFIG__SEMAPHORES:
				getSemaphores().clear();
				getSemaphores().addAll((Collection<? extends Semaphore>)newValue);
				return;
			case ModelPackage.RTOS_CONFIG__SPINLOCKS:
				getSpinlocks().clear();
				getSpinlocks().addAll((Collection<? extends Spinlock>)newValue);
				return;
			case ModelPackage.RTOS_CONFIG__EVENTS:
				getEvents().clear();
				getEvents().addAll((Collection<? extends Event>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.RTOS_CONFIG__SCHEDULABLES:
				getSchedulables().clear();
				return;
			case ModelPackage.RTOS_CONFIG__SEMAPHORES:
				getSemaphores().clear();
				return;
			case ModelPackage.RTOS_CONFIG__SPINLOCKS:
				getSpinlocks().clear();
				return;
			case ModelPackage.RTOS_CONFIG__EVENTS:
				getEvents().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.RTOS_CONFIG__SCHEDULABLES:
				return schedulables != null && !schedulables.isEmpty();
			case ModelPackage.RTOS_CONFIG__SEMAPHORES:
				return semaphores != null && !semaphores.isEmpty();
			case ModelPackage.RTOS_CONFIG__SPINLOCKS:
				return spinlocks != null && !spinlocks.isEmpty();
			case ModelPackage.RTOS_CONFIG__EVENTS:
				return events != null && !events.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //RtosConfigImpl
