/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.SourceFunction;
import com.inchron.realtime.root.model.SpecSettings;
import com.inchron.realtime.root.model.TranslationUnit;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Translation Unit</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.TranslationUnitImpl#getSourceFunctions <em>Source Functions</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.TranslationUnitImpl#getSpecSettings <em>Spec Settings</em>}</li>
 * </ul>
 *
 * @generated
 */
public class TranslationUnitImpl extends ModelObjectImpl implements TranslationUnit {
	/**
	 * The cached value of the '{@link #getSourceFunctions() <em>Source Functions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSourceFunctions()
	 * @generated
	 * @ordered
	 */
	protected EList<SourceFunction> sourceFunctions;

	/**
	 * The cached value of the '{@link #getSpecSettings() <em>Spec Settings</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpecSettings()
	 * @generated
	 * @ordered
	 */
	protected SpecSettings specSettings;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TranslationUnitImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getTranslationUnit();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SourceFunction> getSourceFunctions() {
		if (sourceFunctions == null) {
			sourceFunctions = new EObjectContainmentEList<SourceFunction>(SourceFunction.class, this, ModelPackage.TRANSLATION_UNIT__SOURCE_FUNCTIONS);
		}
		return sourceFunctions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SpecSettings getSpecSettings() {
		return specSettings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSpecSettings(SpecSettings newSpecSettings, NotificationChain msgs) {
		SpecSettings oldSpecSettings = specSettings;
		specSettings = newSpecSettings;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.TRANSLATION_UNIT__SPEC_SETTINGS, oldSpecSettings, newSpecSettings);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSpecSettings(SpecSettings newSpecSettings) {
		if (newSpecSettings != specSettings) {
			NotificationChain msgs = null;
			if (specSettings != null)
				msgs = ((InternalEObject)specSettings).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.TRANSLATION_UNIT__SPEC_SETTINGS, null, msgs);
			if (newSpecSettings != null)
				msgs = ((InternalEObject)newSpecSettings).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.TRANSLATION_UNIT__SPEC_SETTINGS, null, msgs);
			msgs = basicSetSpecSettings(newSpecSettings, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.TRANSLATION_UNIT__SPEC_SETTINGS, newSpecSettings, newSpecSettings));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.TRANSLATION_UNIT__SOURCE_FUNCTIONS:
				return ((InternalEList<?>)getSourceFunctions()).basicRemove(otherEnd, msgs);
			case ModelPackage.TRANSLATION_UNIT__SPEC_SETTINGS:
				return basicSetSpecSettings(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.TRANSLATION_UNIT__SOURCE_FUNCTIONS:
				return getSourceFunctions();
			case ModelPackage.TRANSLATION_UNIT__SPEC_SETTINGS:
				return getSpecSettings();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.TRANSLATION_UNIT__SOURCE_FUNCTIONS:
				getSourceFunctions().clear();
				getSourceFunctions().addAll((Collection<? extends SourceFunction>)newValue);
				return;
			case ModelPackage.TRANSLATION_UNIT__SPEC_SETTINGS:
				setSpecSettings((SpecSettings)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.TRANSLATION_UNIT__SOURCE_FUNCTIONS:
				getSourceFunctions().clear();
				return;
			case ModelPackage.TRANSLATION_UNIT__SPEC_SETTINGS:
				setSpecSettings((SpecSettings)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.TRANSLATION_UNIT__SOURCE_FUNCTIONS:
				return sourceFunctions != null && !sourceFunctions.isEmpty();
			case ModelPackage.TRANSLATION_UNIT__SPEC_SETTINGS:
				return specSettings != null;
		}
		return super.eIsSet(featureID);
	}

} //TranslationUnitImpl
