/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.memory.impl;

import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.TraceObject;

import com.inchron.realtime.root.model.impl.ModelObjectImpl;

import com.inchron.realtime.root.model.memory.InitiatorPort;
import com.inchron.realtime.root.model.memory.MemoryPackage;
import com.inchron.realtime.root.model.memory.ResponderPort;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Responder Port</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.ResponderPortImpl#getObjectId <em>Object Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.ResponderPortImpl#getReadAccessPattern <em>Read Access Pattern</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.ResponderPortImpl#getWriteAccessPattern <em>Write Access Pattern</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.ResponderPortImpl#getInitiator <em>Initiator</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ResponderPortImpl extends ModelObjectImpl implements ResponderPort {
	/**
	 * The default value of the '{@link #getObjectId() <em>Object Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjectId()
	 * @generated
	 * @ordered
	 */
	protected static final int OBJECT_ID_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getObjectId() <em>Object Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjectId()
	 * @generated
	 * @ordered
	 */
	protected int objectId = OBJECT_ID_EDEFAULT;

	/**
	 * This is true if the Object Id attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean objectIdESet;

	/**
	 * The default value of the '{@link #getReadAccessPattern() <em>Read Access Pattern</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReadAccessPattern()
	 * @generated
	 * @ordered
	 */
	protected static final String READ_ACCESS_PATTERN_EDEFAULT = "1-1-1-1";

	/**
	 * The cached value of the '{@link #getReadAccessPattern() <em>Read Access Pattern</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReadAccessPattern()
	 * @generated
	 * @ordered
	 */
	protected String readAccessPattern = READ_ACCESS_PATTERN_EDEFAULT;

	/**
	 * The default value of the '{@link #getWriteAccessPattern() <em>Write Access Pattern</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getWriteAccessPattern()
	 * @generated
	 * @ordered
	 */
	protected static final String WRITE_ACCESS_PATTERN_EDEFAULT = "1-1-1-1";

	/**
	 * The cached value of the '{@link #getWriteAccessPattern() <em>Write Access Pattern</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getWriteAccessPattern()
	 * @generated
	 * @ordered
	 */
	protected String writeAccessPattern = WRITE_ACCESS_PATTERN_EDEFAULT;

	/**
	 * The cached value of the '{@link #getInitiator() <em>Initiator</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInitiator()
	 * @generated
	 * @ordered
	 */
	protected InitiatorPort initiator;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ResponderPortImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MemoryPackage.Literals.RESPONDER_PORT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getObjectId() {
		return objectId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setObjectId(int newObjectId) {
		int oldObjectId = objectId;
		objectId = newObjectId;
		boolean oldObjectIdESet = objectIdESet;
		objectIdESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.RESPONDER_PORT__OBJECT_ID, oldObjectId, objectId, !oldObjectIdESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetObjectId() {
		int oldObjectId = objectId;
		boolean oldObjectIdESet = objectIdESet;
		objectId = OBJECT_ID_EDEFAULT;
		objectIdESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, MemoryPackage.RESPONDER_PORT__OBJECT_ID, oldObjectId, OBJECT_ID_EDEFAULT, oldObjectIdESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetObjectId() {
		return objectIdESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getReadAccessPattern() {
		return readAccessPattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setReadAccessPattern(String newReadAccessPattern) {
		String oldReadAccessPattern = readAccessPattern;
		readAccessPattern = newReadAccessPattern;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.RESPONDER_PORT__READ_ACCESS_PATTERN, oldReadAccessPattern, readAccessPattern));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getWriteAccessPattern() {
		return writeAccessPattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setWriteAccessPattern(String newWriteAccessPattern) {
		String oldWriteAccessPattern = writeAccessPattern;
		writeAccessPattern = newWriteAccessPattern;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.RESPONDER_PORT__WRITE_ACCESS_PATTERN, oldWriteAccessPattern, writeAccessPattern));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InitiatorPort getInitiator() {
		if (initiator != null && initiator.eIsProxy()) {
			InternalEObject oldInitiator = (InternalEObject)initiator;
			initiator = (InitiatorPort)eResolveProxy(oldInitiator);
			if (initiator != oldInitiator) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, MemoryPackage.RESPONDER_PORT__INITIATOR, oldInitiator, initiator));
			}
		}
		return initiator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InitiatorPort basicGetInitiator() {
		return initiator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInitiator(InitiatorPort newInitiator, NotificationChain msgs) {
		InitiatorPort oldInitiator = initiator;
		initiator = newInitiator;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MemoryPackage.RESPONDER_PORT__INITIATOR, oldInitiator, newInitiator);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInitiator(InitiatorPort newInitiator) {
		if (newInitiator != initiator) {
			NotificationChain msgs = null;
			if (initiator != null)
				msgs = ((InternalEObject)initiator).eInverseRemove(this, MemoryPackage.INITIATOR_PORT__RESPONDER, InitiatorPort.class, msgs);
			if (newInitiator != null)
				msgs = ((InternalEObject)newInitiator).eInverseAdd(this, MemoryPackage.INITIATOR_PORT__RESPONDER, InitiatorPort.class, msgs);
			msgs = basicSetInitiator(newInitiator, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.RESPONDER_PORT__INITIATOR, newInitiator, newInitiator));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MemoryPackage.RESPONDER_PORT__INITIATOR:
				if (initiator != null)
					msgs = ((InternalEObject)initiator).eInverseRemove(this, MemoryPackage.INITIATOR_PORT__RESPONDER, InitiatorPort.class, msgs);
				return basicSetInitiator((InitiatorPort)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MemoryPackage.RESPONDER_PORT__INITIATOR:
				return basicSetInitiator(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MemoryPackage.RESPONDER_PORT__OBJECT_ID:
				return getObjectId();
			case MemoryPackage.RESPONDER_PORT__READ_ACCESS_PATTERN:
				return getReadAccessPattern();
			case MemoryPackage.RESPONDER_PORT__WRITE_ACCESS_PATTERN:
				return getWriteAccessPattern();
			case MemoryPackage.RESPONDER_PORT__INITIATOR:
				if (resolve) return getInitiator();
				return basicGetInitiator();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MemoryPackage.RESPONDER_PORT__OBJECT_ID:
				setObjectId((Integer)newValue);
				return;
			case MemoryPackage.RESPONDER_PORT__READ_ACCESS_PATTERN:
				setReadAccessPattern((String)newValue);
				return;
			case MemoryPackage.RESPONDER_PORT__WRITE_ACCESS_PATTERN:
				setWriteAccessPattern((String)newValue);
				return;
			case MemoryPackage.RESPONDER_PORT__INITIATOR:
				setInitiator((InitiatorPort)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MemoryPackage.RESPONDER_PORT__OBJECT_ID:
				unsetObjectId();
				return;
			case MemoryPackage.RESPONDER_PORT__READ_ACCESS_PATTERN:
				setReadAccessPattern(READ_ACCESS_PATTERN_EDEFAULT);
				return;
			case MemoryPackage.RESPONDER_PORT__WRITE_ACCESS_PATTERN:
				setWriteAccessPattern(WRITE_ACCESS_PATTERN_EDEFAULT);
				return;
			case MemoryPackage.RESPONDER_PORT__INITIATOR:
				setInitiator((InitiatorPort)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MemoryPackage.RESPONDER_PORT__OBJECT_ID:
				return isSetObjectId();
			case MemoryPackage.RESPONDER_PORT__READ_ACCESS_PATTERN:
				return READ_ACCESS_PATTERN_EDEFAULT == null ? readAccessPattern != null : !READ_ACCESS_PATTERN_EDEFAULT.equals(readAccessPattern);
			case MemoryPackage.RESPONDER_PORT__WRITE_ACCESS_PATTERN:
				return WRITE_ACCESS_PATTERN_EDEFAULT == null ? writeAccessPattern != null : !WRITE_ACCESS_PATTERN_EDEFAULT.equals(writeAccessPattern);
			case MemoryPackage.RESPONDER_PORT__INITIATOR:
				return initiator != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == TraceObject.class) {
			switch (derivedFeatureID) {
				case MemoryPackage.RESPONDER_PORT__OBJECT_ID: return ModelPackage.TRACE_OBJECT__OBJECT_ID;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == TraceObject.class) {
			switch (baseFeatureID) {
				case ModelPackage.TRACE_OBJECT__OBJECT_ID: return MemoryPackage.RESPONDER_PORT__OBJECT_ID;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (objectId: ");
		if (objectIdESet) result.append(objectId); else result.append("<unset>");
		result.append(", readAccessPattern: ");
		result.append(readAccessPattern);
		result.append(", writeAccessPattern: ");
		result.append(writeAccessPattern);
		result.append(')');
		return result.toString();
	}

} //ResponderPortImpl
