/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Ethernet</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.Ethernet#getMacAddress <em>Mac Address</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.Ethernet#isCrossOver <em>Cross Over</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.Ethernet#getRxQueueSize <em>Rx Queue Size</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getEthernet()
 * @model
 * @generated
 */
public interface Ethernet extends AbstractEthernet {
	/**
	 * Returns the value of the '<em><b>Mac Address</b></em>' attribute.
	 * The default value is <code>"00:00:00:00:00:00"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mac Address</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mac Address</em>' attribute.
	 * @see #setMacAddress(String)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getEthernet_MacAddress()
	 * @model default="00:00:00:00:00:00"
	 * @generated
	 */
	String getMacAddress();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.Ethernet#getMacAddress <em>Mac Address</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mac Address</em>' attribute.
	 * @see #getMacAddress()
	 * @generated
	 */
	void setMacAddress(String value);

	/**
	 * Returns the value of the '<em><b>Cross Over</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cross Over</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cross Over</em>' attribute.
	 * @see #setCrossOver(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getEthernet_CrossOver()
	 * @model default="false"
	 * @generated
	 */
	boolean isCrossOver();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.Ethernet#isCrossOver <em>Cross Over</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cross Over</em>' attribute.
	 * @see #isCrossOver()
	 * @generated
	 */
	void setCrossOver(boolean value);

	/**
	 * Returns the value of the '<em><b>Rx Queue Size</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Rx Queue Size</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rx Queue Size</em>' attribute.
	 * @see #setRxQueueSize(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getEthernet_RxQueueSize()
	 * @model default="0"
	 * @generated
	 */
	int getRxQueueSize();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.Ethernet#getRxQueueSize <em>Rx Queue Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Rx Queue Size</em>' attribute.
	 * @see #getRxQueueSize()
	 * @generated
	 */
	void setRxQueueSize(int value);

} // Ethernet
