/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.model.peripheral.FlexRay;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Flex Ray</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl#isColdStarter <em>Cold Starter</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl#isPSingleSlotEnabled <em>PSingle Slot Enabled</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl#getPKeySlotId <em>PKey Slot Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl#isPKeySlotUsedForStartup <em>PKey Slot Used For Startup</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl#isPKeySlotUsedForSync <em>PKey Slot Used For Sync</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl#getPdMicrotick <em>Pd Microtick</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl#getPLatestTx <em>PLatest Tx</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl#getPdListenTimeOut <em>Pd Listen Time Out</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl#getPdMaxDrift <em>Pd Max Drift</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl#isPAllowHaltDueToClock <em>PAllow Halt Due To Clock</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl#getPAllowPassiveToActive <em>PAllow Passive To Active</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl#getPOffsetCorrectionOut <em>POffset Correction Out</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl#getPRateCorrectionOut <em>PRate Correction Out</em>}</li>
 * </ul>
 *
 * @generated
 */
public class FlexRayImpl extends PeripheralImpl implements FlexRay {
	/**
	 * The default value of the '{@link #isColdStarter() <em>Cold Starter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isColdStarter()
	 * @generated
	 * @ordered
	 */
	protected static final boolean COLD_STARTER_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isColdStarter() <em>Cold Starter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isColdStarter()
	 * @generated
	 * @ordered
	 */
	protected boolean coldStarter = COLD_STARTER_EDEFAULT;

	/**
	 * The default value of the '{@link #isPSingleSlotEnabled() <em>PSingle Slot Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPSingleSlotEnabled()
	 * @generated
	 * @ordered
	 */
	protected static final boolean PSINGLE_SLOT_ENABLED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isPSingleSlotEnabled() <em>PSingle Slot Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPSingleSlotEnabled()
	 * @generated
	 * @ordered
	 */
	protected boolean pSingleSlotEnabled = PSINGLE_SLOT_ENABLED_EDEFAULT;

	/**
	 * The default value of the '{@link #getPKeySlotId() <em>PKey Slot Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPKeySlotId()
	 * @generated
	 * @ordered
	 */
	protected static final int PKEY_SLOT_ID_EDEFAULT = 1;

	/**
	 * The cached value of the '{@link #getPKeySlotId() <em>PKey Slot Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPKeySlotId()
	 * @generated
	 * @ordered
	 */
	protected int pKeySlotId = PKEY_SLOT_ID_EDEFAULT;

	/**
	 * The default value of the '{@link #isPKeySlotUsedForStartup() <em>PKey Slot Used For Startup</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPKeySlotUsedForStartup()
	 * @generated
	 * @ordered
	 */
	protected static final boolean PKEY_SLOT_USED_FOR_STARTUP_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isPKeySlotUsedForStartup() <em>PKey Slot Used For Startup</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPKeySlotUsedForStartup()
	 * @generated
	 * @ordered
	 */
	protected boolean pKeySlotUsedForStartup = PKEY_SLOT_USED_FOR_STARTUP_EDEFAULT;

	/**
	 * The default value of the '{@link #isPKeySlotUsedForSync() <em>PKey Slot Used For Sync</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPKeySlotUsedForSync()
	 * @generated
	 * @ordered
	 */
	protected static final boolean PKEY_SLOT_USED_FOR_SYNC_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isPKeySlotUsedForSync() <em>PKey Slot Used For Sync</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPKeySlotUsedForSync()
	 * @generated
	 * @ordered
	 */
	protected boolean pKeySlotUsedForSync = PKEY_SLOT_USED_FOR_SYNC_EDEFAULT;

	/**
	 * The default value of the '{@link #getPdMicrotick() <em>Pd Microtick</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPdMicrotick()
	 * @generated
	 * @ordered
	 */
	protected static final double PD_MICROTICK_EDEFAULT = 0.025;

	/**
	 * The cached value of the '{@link #getPdMicrotick() <em>Pd Microtick</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPdMicrotick()
	 * @generated
	 * @ordered
	 */
	protected double pdMicrotick = PD_MICROTICK_EDEFAULT;

	/**
	 * The default value of the '{@link #getPLatestTx() <em>PLatest Tx</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPLatestTx()
	 * @generated
	 * @ordered
	 */
	protected static final int PLATEST_TX_EDEFAULT = 243;

	/**
	 * The cached value of the '{@link #getPLatestTx() <em>PLatest Tx</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPLatestTx()
	 * @generated
	 * @ordered
	 */
	protected int pLatestTx = PLATEST_TX_EDEFAULT;

	/**
	 * The default value of the '{@link #getPdListenTimeOut() <em>Pd Listen Time Out</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPdListenTimeOut()
	 * @generated
	 * @ordered
	 */
	protected static final int PD_LISTEN_TIME_OUT_EDEFAULT = 401202;

	/**
	 * The cached value of the '{@link #getPdListenTimeOut() <em>Pd Listen Time Out</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPdListenTimeOut()
	 * @generated
	 * @ordered
	 */
	protected int pdListenTimeOut = PD_LISTEN_TIME_OUT_EDEFAULT;

	/**
	 * The default value of the '{@link #getPdMaxDrift() <em>Pd Max Drift</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPdMaxDrift()
	 * @generated
	 * @ordered
	 */
	protected static final int PD_MAX_DRIFT_EDEFAULT = 601;

	/**
	 * The cached value of the '{@link #getPdMaxDrift() <em>Pd Max Drift</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPdMaxDrift()
	 * @generated
	 * @ordered
	 */
	protected int pdMaxDrift = PD_MAX_DRIFT_EDEFAULT;

	/**
	 * The default value of the '{@link #isPAllowHaltDueToClock() <em>PAllow Halt Due To Clock</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPAllowHaltDueToClock()
	 * @generated
	 * @ordered
	 */
	protected static final boolean PALLOW_HALT_DUE_TO_CLOCK_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isPAllowHaltDueToClock() <em>PAllow Halt Due To Clock</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPAllowHaltDueToClock()
	 * @generated
	 * @ordered
	 */
	protected boolean pAllowHaltDueToClock = PALLOW_HALT_DUE_TO_CLOCK_EDEFAULT;

	/**
	 * The default value of the '{@link #getPAllowPassiveToActive() <em>PAllow Passive To Active</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPAllowPassiveToActive()
	 * @generated
	 * @ordered
	 */
	protected static final int PALLOW_PASSIVE_TO_ACTIVE_EDEFAULT = 1;

	/**
	 * The cached value of the '{@link #getPAllowPassiveToActive() <em>PAllow Passive To Active</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPAllowPassiveToActive()
	 * @generated
	 * @ordered
	 */
	protected int pAllowPassiveToActive = PALLOW_PASSIVE_TO_ACTIVE_EDEFAULT;

	/**
	 * The default value of the '{@link #getPOffsetCorrectionOut() <em>POffset Correction Out</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPOffsetCorrectionOut()
	 * @generated
	 * @ordered
	 */
	protected static final int POFFSET_CORRECTION_OUT_EDEFAULT = 261;

	/**
	 * The cached value of the '{@link #getPOffsetCorrectionOut() <em>POffset Correction Out</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPOffsetCorrectionOut()
	 * @generated
	 * @ordered
	 */
	protected int pOffsetCorrectionOut = POFFSET_CORRECTION_OUT_EDEFAULT;

	/**
	 * The default value of the '{@link #getPRateCorrectionOut() <em>PRate Correction Out</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPRateCorrectionOut()
	 * @generated
	 * @ordered
	 */
	protected static final int PRATE_CORRECTION_OUT_EDEFAULT = 601;

	/**
	 * The cached value of the '{@link #getPRateCorrectionOut() <em>PRate Correction Out</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPRateCorrectionOut()
	 * @generated
	 * @ordered
	 */
	protected int pRateCorrectionOut = PRATE_CORRECTION_OUT_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FlexRayImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PeripheralPackage.Literals.FLEX_RAY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isColdStarter() {
		return coldStarter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setColdStarter(boolean newColdStarter) {
		boolean oldColdStarter = coldStarter;
		coldStarter = newColdStarter;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY__COLD_STARTER, oldColdStarter, coldStarter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isPSingleSlotEnabled() {
		return pSingleSlotEnabled;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPSingleSlotEnabled(boolean newPSingleSlotEnabled) {
		boolean oldPSingleSlotEnabled = pSingleSlotEnabled;
		pSingleSlotEnabled = newPSingleSlotEnabled;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY__PSINGLE_SLOT_ENABLED, oldPSingleSlotEnabled, pSingleSlotEnabled));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getPKeySlotId() {
		return pKeySlotId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPKeySlotId(int newPKeySlotId) {
		int oldPKeySlotId = pKeySlotId;
		pKeySlotId = newPKeySlotId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY__PKEY_SLOT_ID, oldPKeySlotId, pKeySlotId));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isPKeySlotUsedForStartup() {
		return pKeySlotUsedForStartup;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPKeySlotUsedForStartup(boolean newPKeySlotUsedForStartup) {
		boolean oldPKeySlotUsedForStartup = pKeySlotUsedForStartup;
		pKeySlotUsedForStartup = newPKeySlotUsedForStartup;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY__PKEY_SLOT_USED_FOR_STARTUP, oldPKeySlotUsedForStartup, pKeySlotUsedForStartup));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isPKeySlotUsedForSync() {
		return pKeySlotUsedForSync;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPKeySlotUsedForSync(boolean newPKeySlotUsedForSync) {
		boolean oldPKeySlotUsedForSync = pKeySlotUsedForSync;
		pKeySlotUsedForSync = newPKeySlotUsedForSync;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY__PKEY_SLOT_USED_FOR_SYNC, oldPKeySlotUsedForSync, pKeySlotUsedForSync));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getPdMicrotick() {
		return pdMicrotick;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPdMicrotick(double newPdMicrotick) {
		double oldPdMicrotick = pdMicrotick;
		pdMicrotick = newPdMicrotick;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY__PD_MICROTICK, oldPdMicrotick, pdMicrotick));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getPLatestTx() {
		return pLatestTx;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPLatestTx(int newPLatestTx) {
		int oldPLatestTx = pLatestTx;
		pLatestTx = newPLatestTx;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY__PLATEST_TX, oldPLatestTx, pLatestTx));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getPdListenTimeOut() {
		return pdListenTimeOut;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPdListenTimeOut(int newPdListenTimeOut) {
		int oldPdListenTimeOut = pdListenTimeOut;
		pdListenTimeOut = newPdListenTimeOut;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY__PD_LISTEN_TIME_OUT, oldPdListenTimeOut, pdListenTimeOut));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getPdMaxDrift() {
		return pdMaxDrift;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPdMaxDrift(int newPdMaxDrift) {
		int oldPdMaxDrift = pdMaxDrift;
		pdMaxDrift = newPdMaxDrift;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY__PD_MAX_DRIFT, oldPdMaxDrift, pdMaxDrift));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isPAllowHaltDueToClock() {
		return pAllowHaltDueToClock;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPAllowHaltDueToClock(boolean newPAllowHaltDueToClock) {
		boolean oldPAllowHaltDueToClock = pAllowHaltDueToClock;
		pAllowHaltDueToClock = newPAllowHaltDueToClock;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY__PALLOW_HALT_DUE_TO_CLOCK, oldPAllowHaltDueToClock, pAllowHaltDueToClock));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getPAllowPassiveToActive() {
		return pAllowPassiveToActive;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPAllowPassiveToActive(int newPAllowPassiveToActive) {
		int oldPAllowPassiveToActive = pAllowPassiveToActive;
		pAllowPassiveToActive = newPAllowPassiveToActive;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY__PALLOW_PASSIVE_TO_ACTIVE, oldPAllowPassiveToActive, pAllowPassiveToActive));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getPOffsetCorrectionOut() {
		return pOffsetCorrectionOut;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPOffsetCorrectionOut(int newPOffsetCorrectionOut) {
		int oldPOffsetCorrectionOut = pOffsetCorrectionOut;
		pOffsetCorrectionOut = newPOffsetCorrectionOut;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY__POFFSET_CORRECTION_OUT, oldPOffsetCorrectionOut, pOffsetCorrectionOut));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getPRateCorrectionOut() {
		return pRateCorrectionOut;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPRateCorrectionOut(int newPRateCorrectionOut) {
		int oldPRateCorrectionOut = pRateCorrectionOut;
		pRateCorrectionOut = newPRateCorrectionOut;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY__PRATE_CORRECTION_OUT, oldPRateCorrectionOut, pRateCorrectionOut));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PeripheralPackage.FLEX_RAY__COLD_STARTER:
				return isColdStarter();
			case PeripheralPackage.FLEX_RAY__PSINGLE_SLOT_ENABLED:
				return isPSingleSlotEnabled();
			case PeripheralPackage.FLEX_RAY__PKEY_SLOT_ID:
				return getPKeySlotId();
			case PeripheralPackage.FLEX_RAY__PKEY_SLOT_USED_FOR_STARTUP:
				return isPKeySlotUsedForStartup();
			case PeripheralPackage.FLEX_RAY__PKEY_SLOT_USED_FOR_SYNC:
				return isPKeySlotUsedForSync();
			case PeripheralPackage.FLEX_RAY__PD_MICROTICK:
				return getPdMicrotick();
			case PeripheralPackage.FLEX_RAY__PLATEST_TX:
				return getPLatestTx();
			case PeripheralPackage.FLEX_RAY__PD_LISTEN_TIME_OUT:
				return getPdListenTimeOut();
			case PeripheralPackage.FLEX_RAY__PD_MAX_DRIFT:
				return getPdMaxDrift();
			case PeripheralPackage.FLEX_RAY__PALLOW_HALT_DUE_TO_CLOCK:
				return isPAllowHaltDueToClock();
			case PeripheralPackage.FLEX_RAY__PALLOW_PASSIVE_TO_ACTIVE:
				return getPAllowPassiveToActive();
			case PeripheralPackage.FLEX_RAY__POFFSET_CORRECTION_OUT:
				return getPOffsetCorrectionOut();
			case PeripheralPackage.FLEX_RAY__PRATE_CORRECTION_OUT:
				return getPRateCorrectionOut();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PeripheralPackage.FLEX_RAY__COLD_STARTER:
				setColdStarter((Boolean)newValue);
				return;
			case PeripheralPackage.FLEX_RAY__PSINGLE_SLOT_ENABLED:
				setPSingleSlotEnabled((Boolean)newValue);
				return;
			case PeripheralPackage.FLEX_RAY__PKEY_SLOT_ID:
				setPKeySlotId((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY__PKEY_SLOT_USED_FOR_STARTUP:
				setPKeySlotUsedForStartup((Boolean)newValue);
				return;
			case PeripheralPackage.FLEX_RAY__PKEY_SLOT_USED_FOR_SYNC:
				setPKeySlotUsedForSync((Boolean)newValue);
				return;
			case PeripheralPackage.FLEX_RAY__PD_MICROTICK:
				setPdMicrotick((Double)newValue);
				return;
			case PeripheralPackage.FLEX_RAY__PLATEST_TX:
				setPLatestTx((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY__PD_LISTEN_TIME_OUT:
				setPdListenTimeOut((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY__PD_MAX_DRIFT:
				setPdMaxDrift((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY__PALLOW_HALT_DUE_TO_CLOCK:
				setPAllowHaltDueToClock((Boolean)newValue);
				return;
			case PeripheralPackage.FLEX_RAY__PALLOW_PASSIVE_TO_ACTIVE:
				setPAllowPassiveToActive((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY__POFFSET_CORRECTION_OUT:
				setPOffsetCorrectionOut((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY__PRATE_CORRECTION_OUT:
				setPRateCorrectionOut((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PeripheralPackage.FLEX_RAY__COLD_STARTER:
				setColdStarter(COLD_STARTER_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY__PSINGLE_SLOT_ENABLED:
				setPSingleSlotEnabled(PSINGLE_SLOT_ENABLED_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY__PKEY_SLOT_ID:
				setPKeySlotId(PKEY_SLOT_ID_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY__PKEY_SLOT_USED_FOR_STARTUP:
				setPKeySlotUsedForStartup(PKEY_SLOT_USED_FOR_STARTUP_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY__PKEY_SLOT_USED_FOR_SYNC:
				setPKeySlotUsedForSync(PKEY_SLOT_USED_FOR_SYNC_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY__PD_MICROTICK:
				setPdMicrotick(PD_MICROTICK_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY__PLATEST_TX:
				setPLatestTx(PLATEST_TX_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY__PD_LISTEN_TIME_OUT:
				setPdListenTimeOut(PD_LISTEN_TIME_OUT_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY__PD_MAX_DRIFT:
				setPdMaxDrift(PD_MAX_DRIFT_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY__PALLOW_HALT_DUE_TO_CLOCK:
				setPAllowHaltDueToClock(PALLOW_HALT_DUE_TO_CLOCK_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY__PALLOW_PASSIVE_TO_ACTIVE:
				setPAllowPassiveToActive(PALLOW_PASSIVE_TO_ACTIVE_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY__POFFSET_CORRECTION_OUT:
				setPOffsetCorrectionOut(POFFSET_CORRECTION_OUT_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY__PRATE_CORRECTION_OUT:
				setPRateCorrectionOut(PRATE_CORRECTION_OUT_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PeripheralPackage.FLEX_RAY__COLD_STARTER:
				return coldStarter != COLD_STARTER_EDEFAULT;
			case PeripheralPackage.FLEX_RAY__PSINGLE_SLOT_ENABLED:
				return pSingleSlotEnabled != PSINGLE_SLOT_ENABLED_EDEFAULT;
			case PeripheralPackage.FLEX_RAY__PKEY_SLOT_ID:
				return pKeySlotId != PKEY_SLOT_ID_EDEFAULT;
			case PeripheralPackage.FLEX_RAY__PKEY_SLOT_USED_FOR_STARTUP:
				return pKeySlotUsedForStartup != PKEY_SLOT_USED_FOR_STARTUP_EDEFAULT;
			case PeripheralPackage.FLEX_RAY__PKEY_SLOT_USED_FOR_SYNC:
				return pKeySlotUsedForSync != PKEY_SLOT_USED_FOR_SYNC_EDEFAULT;
			case PeripheralPackage.FLEX_RAY__PD_MICROTICK:
				return pdMicrotick != PD_MICROTICK_EDEFAULT;
			case PeripheralPackage.FLEX_RAY__PLATEST_TX:
				return pLatestTx != PLATEST_TX_EDEFAULT;
			case PeripheralPackage.FLEX_RAY__PD_LISTEN_TIME_OUT:
				return pdListenTimeOut != PD_LISTEN_TIME_OUT_EDEFAULT;
			case PeripheralPackage.FLEX_RAY__PD_MAX_DRIFT:
				return pdMaxDrift != PD_MAX_DRIFT_EDEFAULT;
			case PeripheralPackage.FLEX_RAY__PALLOW_HALT_DUE_TO_CLOCK:
				return pAllowHaltDueToClock != PALLOW_HALT_DUE_TO_CLOCK_EDEFAULT;
			case PeripheralPackage.FLEX_RAY__PALLOW_PASSIVE_TO_ACTIVE:
				return pAllowPassiveToActive != PALLOW_PASSIVE_TO_ACTIVE_EDEFAULT;
			case PeripheralPackage.FLEX_RAY__POFFSET_CORRECTION_OUT:
				return pOffsetCorrectionOut != POFFSET_CORRECTION_OUT_EDEFAULT;
			case PeripheralPackage.FLEX_RAY__PRATE_CORRECTION_OUT:
				return pRateCorrectionOut != PRATE_CORRECTION_OUT_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (coldStarter: ");
		result.append(coldStarter);
		result.append(", pSingleSlotEnabled: ");
		result.append(pSingleSlotEnabled);
		result.append(", pKeySlotId: ");
		result.append(pKeySlotId);
		result.append(", pKeySlotUsedForStartup: ");
		result.append(pKeySlotUsedForStartup);
		result.append(", pKeySlotUsedForSync: ");
		result.append(pKeySlotUsedForSync);
		result.append(", pdMicrotick: ");
		result.append(pdMicrotick);
		result.append(", pLatestTx: ");
		result.append(pLatestTx);
		result.append(", pdListenTimeOut: ");
		result.append(pdListenTimeOut);
		result.append(", pdMaxDrift: ");
		result.append(pdMaxDrift);
		result.append(", pAllowHaltDueToClock: ");
		result.append(pAllowHaltDueToClock);
		result.append(", pAllowPassiveToActive: ");
		result.append(pAllowPassiveToActive);
		result.append(", pOffsetCorrectionOut: ");
		result.append(pOffsetCorrectionOut);
		result.append(", pRateCorrectionOut: ");
		result.append(pRateCorrectionOut);
		result.append(')');
		return result.toString();
	}

} //FlexRayImpl
