/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.model.AddressRange;

import com.inchron.realtime.root.model.peripheral.Peripheral;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Peripheral</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.PeripheralImpl#getAddressRange <em>Address Range</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class PeripheralImpl extends AbstractPeripheralImpl implements Peripheral {
	/**
	 * The cached value of the '{@link #getAddressRange() <em>Address Range</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAddressRange()
	 * @generated
	 * @ordered
	 */
	protected AddressRange addressRange;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PeripheralImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PeripheralPackage.Literals.PERIPHERAL;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AddressRange getAddressRange() {
		return addressRange;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetAddressRange(AddressRange newAddressRange, NotificationChain msgs) {
		AddressRange oldAddressRange = addressRange;
		addressRange = newAddressRange;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PeripheralPackage.PERIPHERAL__ADDRESS_RANGE, oldAddressRange, newAddressRange);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAddressRange(AddressRange newAddressRange) {
		if (newAddressRange != addressRange) {
			NotificationChain msgs = null;
			if (addressRange != null)
				msgs = ((InternalEObject)addressRange).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PeripheralPackage.PERIPHERAL__ADDRESS_RANGE, null, msgs);
			if (newAddressRange != null)
				msgs = ((InternalEObject)newAddressRange).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PeripheralPackage.PERIPHERAL__ADDRESS_RANGE, null, msgs);
			msgs = basicSetAddressRange(newAddressRange, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.PERIPHERAL__ADDRESS_RANGE, newAddressRange, newAddressRange));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case PeripheralPackage.PERIPHERAL__ADDRESS_RANGE:
				return basicSetAddressRange(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PeripheralPackage.PERIPHERAL__ADDRESS_RANGE:
				return getAddressRange();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PeripheralPackage.PERIPHERAL__ADDRESS_RANGE:
				setAddressRange((AddressRange)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PeripheralPackage.PERIPHERAL__ADDRESS_RANGE:
				setAddressRange((AddressRange)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PeripheralPackage.PERIPHERAL__ADDRESS_RANGE:
				return addressRange != null;
		}
		return super.eIsSet(featureID);
	}

} //PeripheralImpl
