/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import com.inchron.realtime.root.model.TimeInterval;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Timing Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getInterval <em>Interval</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.TimingRequirement#isSuccessIfOutsideOfInterval <em>Success If Outside Of Interval</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getPrewarnMarginAtLowerLimit <em>Prewarn Margin At Lower Limit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getPrewarnMarginAtUpperLimit <em>Prewarn Margin At Upper Limit</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getTimingRequirement()
 * @model abstract="true"
 * @generated
 */
public interface TimingRequirement extends Requirement {
	/**
	 * Returns the value of the '<em><b>Interval</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interval</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interval</em>' containment reference.
	 * @see #setInterval(TimeInterval)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getTimingRequirement_Interval()
	 * @model containment="true" required="true"
	 * @generated
	 */
	TimeInterval getInterval();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getInterval <em>Interval</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Interval</em>' containment reference.
	 * @see #getInterval()
	 * @generated
	 */
	void setInterval(TimeInterval value);

	/**
	 * Returns the value of the '<em><b>Success If Outside Of Interval</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Success If Outside Of Interval</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Success If Outside Of Interval</em>' attribute.
	 * @see #setSuccessIfOutsideOfInterval(boolean)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getTimingRequirement_SuccessIfOutsideOfInterval()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isSuccessIfOutsideOfInterval();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.TimingRequirement#isSuccessIfOutsideOfInterval <em>Success If Outside Of Interval</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Success If Outside Of Interval</em>' attribute.
	 * @see #isSuccessIfOutsideOfInterval()
	 * @generated
	 */
	void setSuccessIfOutsideOfInterval(boolean value);

	/**
	 * Returns the value of the '<em><b>Prewarn Margin At Lower Limit</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Prewarn Margin At Lower Limit</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Prewarn Margin At Lower Limit</em>' attribute.
	 * @see #setPrewarnMarginAtLowerLimit(float)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getTimingRequirement_PrewarnMarginAtLowerLimit()
	 * @model default="0" required="true"
	 * @generated
	 */
	float getPrewarnMarginAtLowerLimit();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getPrewarnMarginAtLowerLimit <em>Prewarn Margin At Lower Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Prewarn Margin At Lower Limit</em>' attribute.
	 * @see #getPrewarnMarginAtLowerLimit()
	 * @generated
	 */
	void setPrewarnMarginAtLowerLimit(float value);

	/**
	 * Returns the value of the '<em><b>Prewarn Margin At Upper Limit</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Prewarn Margin At Upper Limit</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Prewarn Margin At Upper Limit</em>' attribute.
	 * @see #setPrewarnMarginAtUpperLimit(float)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getTimingRequirement_PrewarnMarginAtUpperLimit()
	 * @model default="0" required="true"
	 * @generated
	 */
	float getPrewarnMarginAtUpperLimit();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getPrewarnMarginAtUpperLimit <em>Prewarn Margin At Upper Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Prewarn Margin At Upper Limit</em>' attribute.
	 * @see #getPrewarnMarginAtUpperLimit()
	 * @generated
	 */
	void setPrewarnMarginAtUpperLimit(float value);

} // TimingRequirement
