/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.model.EventChain;
import com.inchron.realtime.root.model.EventChainStep;

import com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement;
import com.inchron.realtime.root.model.requirement.RequirementPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Event Chain Break Off Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventChainBreakOffRequirementImpl#isEvaluateBreakOffAsSuccess <em>Evaluate Break Off As Success</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventChainBreakOffRequirementImpl#getEventChain <em>Event Chain</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventChainBreakOffRequirementImpl#getIgnoreLastInstances <em>Ignore Last Instances</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventChainBreakOffRequirementImpl#isIgnoreNonSequential <em>Ignore Non Sequential</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventChainBreakOffRequirementImpl#isIgnoreSkipped <em>Ignore Skipped</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventChainBreakOffRequirementImpl#getRequiredLastStep <em>Required Last Step</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EventChainBreakOffRequirementImpl extends RequirementImpl implements EventChainBreakOffRequirement {
	/**
	 * The default value of the '{@link #isEvaluateBreakOffAsSuccess() <em>Evaluate Break Off As Success</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEvaluateBreakOffAsSuccess()
	 * @generated
	 * @ordered
	 */
	protected static final boolean EVALUATE_BREAK_OFF_AS_SUCCESS_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isEvaluateBreakOffAsSuccess() <em>Evaluate Break Off As Success</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEvaluateBreakOffAsSuccess()
	 * @generated
	 * @ordered
	 */
	protected boolean evaluateBreakOffAsSuccess = EVALUATE_BREAK_OFF_AS_SUCCESS_EDEFAULT;

	/**
	 * The cached value of the '{@link #getEventChain() <em>Event Chain</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEventChain()
	 * @generated
	 * @ordered
	 */
	protected EventChain eventChain;

	/**
	 * The default value of the '{@link #getIgnoreLastInstances() <em>Ignore Last Instances</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIgnoreLastInstances()
	 * @generated
	 * @ordered
	 */
	protected static final int IGNORE_LAST_INSTANCES_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getIgnoreLastInstances() <em>Ignore Last Instances</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIgnoreLastInstances()
	 * @generated
	 * @ordered
	 */
	protected int ignoreLastInstances = IGNORE_LAST_INSTANCES_EDEFAULT;

	/**
	 * The default value of the '{@link #isIgnoreNonSequential() <em>Ignore Non Sequential</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIgnoreNonSequential()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IGNORE_NON_SEQUENTIAL_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIgnoreNonSequential() <em>Ignore Non Sequential</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIgnoreNonSequential()
	 * @generated
	 * @ordered
	 */
	protected boolean ignoreNonSequential = IGNORE_NON_SEQUENTIAL_EDEFAULT;

	/**
	 * The default value of the '{@link #isIgnoreSkipped() <em>Ignore Skipped</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIgnoreSkipped()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IGNORE_SKIPPED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIgnoreSkipped() <em>Ignore Skipped</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIgnoreSkipped()
	 * @generated
	 * @ordered
	 */
	protected boolean ignoreSkipped = IGNORE_SKIPPED_EDEFAULT;

	/**
	 * The cached value of the '{@link #getRequiredLastStep() <em>Required Last Step</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRequiredLastStep()
	 * @generated
	 * @ordered
	 */
	protected EventChainStep requiredLastStep;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EventChainBreakOffRequirementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RequirementPackage.Literals.EVENT_CHAIN_BREAK_OFF_REQUIREMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isEvaluateBreakOffAsSuccess() {
		return evaluateBreakOffAsSuccess;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEvaluateBreakOffAsSuccess(boolean newEvaluateBreakOffAsSuccess) {
		boolean oldEvaluateBreakOffAsSuccess = evaluateBreakOffAsSuccess;
		evaluateBreakOffAsSuccess = newEvaluateBreakOffAsSuccess;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVALUATE_BREAK_OFF_AS_SUCCESS, oldEvaluateBreakOffAsSuccess, evaluateBreakOffAsSuccess));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChain getEventChain() {
		if (eventChain != null && eventChain.eIsProxy()) {
			InternalEObject oldEventChain = (InternalEObject)eventChain;
			eventChain = (EventChain)eResolveProxy(oldEventChain);
			if (eventChain != oldEventChain) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVENT_CHAIN, oldEventChain, eventChain));
			}
		}
		return eventChain;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChain basicGetEventChain() {
		return eventChain;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEventChain(EventChain newEventChain) {
		EventChain oldEventChain = eventChain;
		eventChain = newEventChain;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVENT_CHAIN, oldEventChain, eventChain));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getIgnoreLastInstances() {
		return ignoreLastInstances;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIgnoreLastInstances(int newIgnoreLastInstances) {
		int oldIgnoreLastInstances = ignoreLastInstances;
		ignoreLastInstances = newIgnoreLastInstances;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_LAST_INSTANCES, oldIgnoreLastInstances, ignoreLastInstances));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIgnoreNonSequential() {
		return ignoreNonSequential;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIgnoreNonSequential(boolean newIgnoreNonSequential) {
		boolean oldIgnoreNonSequential = ignoreNonSequential;
		ignoreNonSequential = newIgnoreNonSequential;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_NON_SEQUENTIAL, oldIgnoreNonSequential, ignoreNonSequential));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIgnoreSkipped() {
		return ignoreSkipped;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIgnoreSkipped(boolean newIgnoreSkipped) {
		boolean oldIgnoreSkipped = ignoreSkipped;
		ignoreSkipped = newIgnoreSkipped;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_SKIPPED, oldIgnoreSkipped, ignoreSkipped));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChainStep getRequiredLastStep() {
		if (requiredLastStep != null && requiredLastStep.eIsProxy()) {
			InternalEObject oldRequiredLastStep = (InternalEObject)requiredLastStep;
			requiredLastStep = (EventChainStep)eResolveProxy(oldRequiredLastStep);
			if (requiredLastStep != oldRequiredLastStep) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__REQUIRED_LAST_STEP, oldRequiredLastStep, requiredLastStep));
			}
		}
		return requiredLastStep;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChainStep basicGetRequiredLastStep() {
		return requiredLastStep;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRequiredLastStep(EventChainStep newRequiredLastStep) {
		EventChainStep oldRequiredLastStep = requiredLastStep;
		requiredLastStep = newRequiredLastStep;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__REQUIRED_LAST_STEP, oldRequiredLastStep, requiredLastStep));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVALUATE_BREAK_OFF_AS_SUCCESS:
				return isEvaluateBreakOffAsSuccess();
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVENT_CHAIN:
				if (resolve) return getEventChain();
				return basicGetEventChain();
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_LAST_INSTANCES:
				return getIgnoreLastInstances();
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_NON_SEQUENTIAL:
				return isIgnoreNonSequential();
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_SKIPPED:
				return isIgnoreSkipped();
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__REQUIRED_LAST_STEP:
				if (resolve) return getRequiredLastStep();
				return basicGetRequiredLastStep();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVALUATE_BREAK_OFF_AS_SUCCESS:
				setEvaluateBreakOffAsSuccess((Boolean)newValue);
				return;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVENT_CHAIN:
				setEventChain((EventChain)newValue);
				return;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_LAST_INSTANCES:
				setIgnoreLastInstances((Integer)newValue);
				return;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_NON_SEQUENTIAL:
				setIgnoreNonSequential((Boolean)newValue);
				return;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_SKIPPED:
				setIgnoreSkipped((Boolean)newValue);
				return;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__REQUIRED_LAST_STEP:
				setRequiredLastStep((EventChainStep)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVALUATE_BREAK_OFF_AS_SUCCESS:
				setEvaluateBreakOffAsSuccess(EVALUATE_BREAK_OFF_AS_SUCCESS_EDEFAULT);
				return;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVENT_CHAIN:
				setEventChain((EventChain)null);
				return;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_LAST_INSTANCES:
				setIgnoreLastInstances(IGNORE_LAST_INSTANCES_EDEFAULT);
				return;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_NON_SEQUENTIAL:
				setIgnoreNonSequential(IGNORE_NON_SEQUENTIAL_EDEFAULT);
				return;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_SKIPPED:
				setIgnoreSkipped(IGNORE_SKIPPED_EDEFAULT);
				return;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__REQUIRED_LAST_STEP:
				setRequiredLastStep((EventChainStep)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVALUATE_BREAK_OFF_AS_SUCCESS:
				return evaluateBreakOffAsSuccess != EVALUATE_BREAK_OFF_AS_SUCCESS_EDEFAULT;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVENT_CHAIN:
				return eventChain != null;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_LAST_INSTANCES:
				return ignoreLastInstances != IGNORE_LAST_INSTANCES_EDEFAULT;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_NON_SEQUENTIAL:
				return ignoreNonSequential != IGNORE_NON_SEQUENTIAL_EDEFAULT;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_SKIPPED:
				return ignoreSkipped != IGNORE_SKIPPED_EDEFAULT;
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT__REQUIRED_LAST_STEP:
				return requiredLastStep != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (evaluateBreakOffAsSuccess: ");
		result.append(evaluateBreakOffAsSuccess);
		result.append(", ignoreLastInstances: ");
		result.append(ignoreLastInstances);
		result.append(", ignoreNonSequential: ");
		result.append(ignoreNonSequential);
		result.append(", ignoreSkipped: ");
		result.append(ignoreSkipped);
		result.append(')');
		return result.toString();
	}

} //EventChainBreakOffRequirementImpl
