/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.model.TraceEvent;

import com.inchron.realtime.root.model.requirement.EventIEventJRequirement;
import com.inchron.realtime.root.model.requirement.RequirementPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Event IEvent JRequirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventIEventJRequirementImpl#getEndEvent <em>End Event</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventIEventJRequirementImpl#getParameterA <em>Parameter A</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventIEventJRequirementImpl#getParameterB <em>Parameter B</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventIEventJRequirementImpl#getStartEvent <em>Start Event</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EventIEventJRequirementImpl extends TimingRequirementImpl implements EventIEventJRequirement {
	/**
	 * The cached value of the '{@link #getEndEvent() <em>End Event</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEndEvent()
	 * @generated
	 * @ordered
	 */
	protected TraceEvent endEvent;

	/**
	 * The default value of the '{@link #getParameterA() <em>Parameter A</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getParameterA()
	 * @generated
	 * @ordered
	 */
	protected static final int PARAMETER_A_EDEFAULT = 1;

	/**
	 * The cached value of the '{@link #getParameterA() <em>Parameter A</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getParameterA()
	 * @generated
	 * @ordered
	 */
	protected int parameterA = PARAMETER_A_EDEFAULT;

	/**
	 * The default value of the '{@link #getParameterB() <em>Parameter B</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getParameterB()
	 * @generated
	 * @ordered
	 */
	protected static final int PARAMETER_B_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getParameterB() <em>Parameter B</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getParameterB()
	 * @generated
	 * @ordered
	 */
	protected int parameterB = PARAMETER_B_EDEFAULT;

	/**
	 * The cached value of the '{@link #getStartEvent() <em>Start Event</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartEvent()
	 * @generated
	 * @ordered
	 */
	protected TraceEvent startEvent;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EventIEventJRequirementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RequirementPackage.Literals.EVENT_IEVENT_JREQUIREMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEvent getEndEvent() {
		if (endEvent != null && endEvent.eIsProxy()) {
			InternalEObject oldEndEvent = (InternalEObject)endEvent;
			endEvent = (TraceEvent)eResolveProxy(oldEndEvent);
			if (endEvent != oldEndEvent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.EVENT_IEVENT_JREQUIREMENT__END_EVENT, oldEndEvent, endEvent));
			}
		}
		return endEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEvent basicGetEndEvent() {
		return endEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEndEvent(TraceEvent newEndEvent) {
		TraceEvent oldEndEvent = endEvent;
		endEvent = newEndEvent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_IEVENT_JREQUIREMENT__END_EVENT, oldEndEvent, endEvent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getParameterA() {
		return parameterA;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParameterA(int newParameterA) {
		int oldParameterA = parameterA;
		parameterA = newParameterA;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_IEVENT_JREQUIREMENT__PARAMETER_A, oldParameterA, parameterA));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getParameterB() {
		return parameterB;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParameterB(int newParameterB) {
		int oldParameterB = parameterB;
		parameterB = newParameterB;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_IEVENT_JREQUIREMENT__PARAMETER_B, oldParameterB, parameterB));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEvent getStartEvent() {
		if (startEvent != null && startEvent.eIsProxy()) {
			InternalEObject oldStartEvent = (InternalEObject)startEvent;
			startEvent = (TraceEvent)eResolveProxy(oldStartEvent);
			if (startEvent != oldStartEvent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.EVENT_IEVENT_JREQUIREMENT__START_EVENT, oldStartEvent, startEvent));
			}
		}
		return startEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEvent basicGetStartEvent() {
		return startEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartEvent(TraceEvent newStartEvent) {
		TraceEvent oldStartEvent = startEvent;
		startEvent = newStartEvent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_IEVENT_JREQUIREMENT__START_EVENT, oldStartEvent, startEvent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__END_EVENT:
				if (resolve) return getEndEvent();
				return basicGetEndEvent();
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__PARAMETER_A:
				return getParameterA();
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__PARAMETER_B:
				return getParameterB();
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__START_EVENT:
				if (resolve) return getStartEvent();
				return basicGetStartEvent();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__END_EVENT:
				setEndEvent((TraceEvent)newValue);
				return;
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__PARAMETER_A:
				setParameterA((Integer)newValue);
				return;
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__PARAMETER_B:
				setParameterB((Integer)newValue);
				return;
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__START_EVENT:
				setStartEvent((TraceEvent)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__END_EVENT:
				setEndEvent((TraceEvent)null);
				return;
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__PARAMETER_A:
				setParameterA(PARAMETER_A_EDEFAULT);
				return;
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__PARAMETER_B:
				setParameterB(PARAMETER_B_EDEFAULT);
				return;
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__START_EVENT:
				setStartEvent((TraceEvent)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__END_EVENT:
				return endEvent != null;
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__PARAMETER_A:
				return parameterA != PARAMETER_A_EDEFAULT;
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__PARAMETER_B:
				return parameterB != PARAMETER_B_EDEFAULT;
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT__START_EVENT:
				return startEvent != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (parameterA: ");
		result.append(parameterA);
		result.append(", parameterB: ");
		result.append(parameterB);
		result.append(')');
		return result.toString();
	}

} //EventIEventJRequirementImpl
