/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.model.impl.ModelObjectImpl;

import com.inchron.realtime.root.model.requirement.Requirement;
import com.inchron.realtime.root.model.requirement.RequirementPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.RequirementImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.RequirementImpl#getEtag <em>Etag</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.RequirementImpl#isEvaluate <em>Evaluate</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.RequirementImpl#getProvidedBy <em>Provided By</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.RequirementImpl#isShow <em>Show</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.RequirementImpl#getUrl <em>Url</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class RequirementImpl extends ModelObjectImpl implements Requirement {
	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getEtag() <em>Etag</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEtag()
	 * @generated
	 * @ordered
	 */
	protected static final String ETAG_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getEtag() <em>Etag</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEtag()
	 * @generated
	 * @ordered
	 */
	protected String etag = ETAG_EDEFAULT;

	/**
	 * The default value of the '{@link #isEvaluate() <em>Evaluate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEvaluate()
	 * @generated
	 * @ordered
	 */
	protected static final boolean EVALUATE_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isEvaluate() <em>Evaluate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEvaluate()
	 * @generated
	 * @ordered
	 */
	protected boolean evaluate = EVALUATE_EDEFAULT;

	/**
	 * The default value of the '{@link #getProvidedBy() <em>Provided By</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProvidedBy()
	 * @generated
	 * @ordered
	 */
	protected static final String PROVIDED_BY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getProvidedBy() <em>Provided By</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProvidedBy()
	 * @generated
	 * @ordered
	 */
	protected String providedBy = PROVIDED_BY_EDEFAULT;

	/**
	 * The default value of the '{@link #isShow() <em>Show</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isShow()
	 * @generated
	 * @ordered
	 */
	protected static final boolean SHOW_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isShow() <em>Show</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isShow()
	 * @generated
	 * @ordered
	 */
	protected boolean show = SHOW_EDEFAULT;

	/**
	 * The default value of the '{@link #getUrl() <em>Url</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUrl()
	 * @generated
	 * @ordered
	 */
	protected static final String URL_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getUrl() <em>Url</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUrl()
	 * @generated
	 * @ordered
	 */
	protected String url = URL_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RequirementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RequirementPackage.Literals.REQUIREMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.REQUIREMENT__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getEtag() {
		return etag;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEtag(String newEtag) {
		String oldEtag = etag;
		etag = newEtag;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.REQUIREMENT__ETAG, oldEtag, etag));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isEvaluate() {
		return evaluate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEvaluate(boolean newEvaluate) {
		boolean oldEvaluate = evaluate;
		evaluate = newEvaluate;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.REQUIREMENT__EVALUATE, oldEvaluate, evaluate));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getProvidedBy() {
		return providedBy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProvidedBy(String newProvidedBy) {
		String oldProvidedBy = providedBy;
		providedBy = newProvidedBy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.REQUIREMENT__PROVIDED_BY, oldProvidedBy, providedBy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isShow() {
		return show;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setShow(boolean newShow) {
		boolean oldShow = show;
		show = newShow;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.REQUIREMENT__SHOW, oldShow, show));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getUrl() {
		return url;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUrl(String newUrl) {
		String oldUrl = url;
		url = newUrl;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.REQUIREMENT__URL, oldUrl, url));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RequirementPackage.REQUIREMENT__DESCRIPTION:
				return getDescription();
			case RequirementPackage.REQUIREMENT__ETAG:
				return getEtag();
			case RequirementPackage.REQUIREMENT__EVALUATE:
				return isEvaluate();
			case RequirementPackage.REQUIREMENT__PROVIDED_BY:
				return getProvidedBy();
			case RequirementPackage.REQUIREMENT__SHOW:
				return isShow();
			case RequirementPackage.REQUIREMENT__URL:
				return getUrl();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RequirementPackage.REQUIREMENT__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case RequirementPackage.REQUIREMENT__ETAG:
				setEtag((String)newValue);
				return;
			case RequirementPackage.REQUIREMENT__EVALUATE:
				setEvaluate((Boolean)newValue);
				return;
			case RequirementPackage.REQUIREMENT__PROVIDED_BY:
				setProvidedBy((String)newValue);
				return;
			case RequirementPackage.REQUIREMENT__SHOW:
				setShow((Boolean)newValue);
				return;
			case RequirementPackage.REQUIREMENT__URL:
				setUrl((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RequirementPackage.REQUIREMENT__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case RequirementPackage.REQUIREMENT__ETAG:
				setEtag(ETAG_EDEFAULT);
				return;
			case RequirementPackage.REQUIREMENT__EVALUATE:
				setEvaluate(EVALUATE_EDEFAULT);
				return;
			case RequirementPackage.REQUIREMENT__PROVIDED_BY:
				setProvidedBy(PROVIDED_BY_EDEFAULT);
				return;
			case RequirementPackage.REQUIREMENT__SHOW:
				setShow(SHOW_EDEFAULT);
				return;
			case RequirementPackage.REQUIREMENT__URL:
				setUrl(URL_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RequirementPackage.REQUIREMENT__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case RequirementPackage.REQUIREMENT__ETAG:
				return ETAG_EDEFAULT == null ? etag != null : !ETAG_EDEFAULT.equals(etag);
			case RequirementPackage.REQUIREMENT__EVALUATE:
				return evaluate != EVALUATE_EDEFAULT;
			case RequirementPackage.REQUIREMENT__PROVIDED_BY:
				return PROVIDED_BY_EDEFAULT == null ? providedBy != null : !PROVIDED_BY_EDEFAULT.equals(providedBy);
			case RequirementPackage.REQUIREMENT__SHOW:
				return show != SHOW_EDEFAULT;
			case RequirementPackage.REQUIREMENT__URL:
				return URL_EDEFAULT == null ? url != null : !URL_EDEFAULT.equals(url);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (description: ");
		result.append(description);
		result.append(", etag: ");
		result.append(etag);
		result.append(", evaluate: ");
		result.append(evaluate);
		result.append(", providedBy: ");
		result.append(providedBy);
		result.append(", show: ");
		result.append(show);
		result.append(", url: ");
		result.append(url);
		result.append(')');
		return result.toString();
	}

} //RequirementImpl
