/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation;

import com.inchron.realtime.root.model.Time;
import com.inchron.realtime.root.model.TimeDistribution;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Burst Pattern Generator</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getBurstPatternSettings <em>Burst Pattern Settings</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getIterations <em>Iterations</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getPeriod <em>Period</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#isRelative <em>Relative</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getStartOffset <em>Start Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getStartOffsetVariation <em>Start Offset Variation</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getVariation <em>Variation</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getBurstPatternGenerator()
 * @model
 * @generated
 */
public interface BurstPatternGenerator extends StimuliGenerator {
	/**
	 * Returns the value of the '<em><b>Burst Pattern Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Burst Pattern Settings</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Burst Pattern Settings</em>' containment reference.
	 * @see #setBurstPatternSettings(BurstPattern)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getBurstPatternGenerator_BurstPatternSettings()
	 * @model containment="true" required="true"
	 * @generated
	 */
	BurstPattern getBurstPatternSettings();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getBurstPatternSettings <em>Burst Pattern Settings</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Burst Pattern Settings</em>' containment reference.
	 * @see #getBurstPatternSettings()
	 * @generated
	 */
	void setBurstPatternSettings(BurstPattern value);

	/**
	 * Returns the value of the '<em><b>Iterations</b></em>' attribute.
	 * The default value is <code>"-1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Iterations</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Iterations</em>' attribute.
	 * @see #setIterations(int)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getBurstPatternGenerator_Iterations()
	 * @model default="-1" required="true"
	 * @generated
	 */
	int getIterations();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getIterations <em>Iterations</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Iterations</em>' attribute.
	 * @see #getIterations()
	 * @generated
	 */
	void setIterations(int value);

	/**
	 * Returns the value of the '<em><b>Period</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Period</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Period</em>' containment reference.
	 * @see #setPeriod(Time)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getBurstPatternGenerator_Period()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getPeriod();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getPeriod <em>Period</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Period</em>' containment reference.
	 * @see #getPeriod()
	 * @generated
	 */
	void setPeriod(Time value);

	/**
	 * Returns the value of the '<em><b>Relative</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Relative</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Relative</em>' attribute.
	 * @see #setRelative(boolean)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getBurstPatternGenerator_Relative()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isRelative();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#isRelative <em>Relative</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Relative</em>' attribute.
	 * @see #isRelative()
	 * @generated
	 */
	void setRelative(boolean value);

	/**
	 * Returns the value of the '<em><b>Start Offset</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Offset</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Offset</em>' containment reference.
	 * @see #setStartOffset(Time)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getBurstPatternGenerator_StartOffset()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getStartOffset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getStartOffset <em>Start Offset</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Offset</em>' containment reference.
	 * @see #getStartOffset()
	 * @generated
	 */
	void setStartOffset(Time value);

	/**
	 * Returns the value of the '<em><b>Start Offset Variation</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Offset Variation</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Offset Variation</em>' containment reference.
	 * @see #setStartOffsetVariation(TimeDistribution)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getBurstPatternGenerator_StartOffsetVariation()
	 * @model containment="true" required="true"
	 * @generated
	 */
	TimeDistribution getStartOffsetVariation();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getStartOffsetVariation <em>Start Offset Variation</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Offset Variation</em>' containment reference.
	 * @see #getStartOffsetVariation()
	 * @generated
	 */
	void setStartOffsetVariation(TimeDistribution value);

	/**
	 * Returns the value of the '<em><b>Variation</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Variation</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Variation</em>' containment reference.
	 * @see #setVariation(TimeDistribution)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getBurstPatternGenerator_Variation()
	 * @model containment="true" required="true"
	 * @generated
	 */
	TimeDistribution getVariation();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getVariation <em>Variation</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Variation</em>' containment reference.
	 * @see #getVariation()
	 * @generated
	 */
	void setVariation(TimeDistribution value);

} // BurstPatternGenerator
