/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.settings;

import com.inchron.realtime.root.model.ModelObject;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Color Entry Container</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.settings.ColorEntryContainer#getObject <em>Object</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.ColorEntryContainer#getColor <em>Color</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.settings.SettingsPackage#getColorEntryContainer()
 * @model
 * @generated
 */
public interface ColorEntryContainer extends EObject {
	/**
	 * Returns the value of the '<em><b>Object</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Object</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Object</em>' reference.
	 * @see #setObject(ModelObject)
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getColorEntryContainer_Object()
	 * @model
	 * @generated
	 */
	ModelObject getObject();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.settings.ColorEntryContainer#getObject <em>Object</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Object</em>' reference.
	 * @see #getObject()
	 * @generated
	 */
	void setObject(ModelObject value);

	/**
	 * Returns the value of the '<em><b>Color</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.settings.Color}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Color</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Color</em>' containment reference list.
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getColorEntryContainer_Color()
	 * @model containment="true" required="true"
	 * @generated
	 */
	EList<Color> getColor();

} // ColorEntryContainer
