/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.settings;

import com.inchron.realtime.root.model.Time;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Cursor</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.settings.Cursor#getPosition <em>Position</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.Cursor#isMaster <em>Master</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.settings.SettingsPackage#getCursor()
 * @model
 * @generated
 */
public interface Cursor extends EObject {
	/**
	 * Returns the value of the '<em><b>Position</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Position</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Position</em>' containment reference.
	 * @see #setPosition(Time)
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getCursor_Position()
	 * @model containment="true"
	 * @generated
	 */
	Time getPosition();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.settings.Cursor#getPosition <em>Position</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Position</em>' containment reference.
	 * @see #getPosition()
	 * @generated
	 */
	void setPosition(Time value);

	/**
	 * Returns the value of the '<em><b>Master</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Master</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Master</em>' attribute.
	 * @see #setMaster(boolean)
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getCursor_Master()
	 * @model default="false"
	 * @generated
	 */
	boolean isMaster();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.settings.Cursor#isMaster <em>Master</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Master</em>' attribute.
	 * @see #isMaster()
	 * @generated
	 */
	void setMaster(boolean value);

} // Cursor
