/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.settings;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Model Settings</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.settings.ModelSettings#getColors <em>Colors</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.ModelSettings#getColorsByInstance <em>Colors By Instance</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.settings.SettingsPackage#getModelSettings()
 * @model
 * @generated
 */
public interface ModelSettings extends EObject {
	/**
	 * Returns the value of the '<em><b>Colors</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.settings.ColorEntry}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Colors</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Colors</em>' containment reference list.
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getModelSettings_Colors()
	 * @model containment="true"
	 * @generated
	 */
	EList<ColorEntry> getColors();

	/**
	 * Returns the value of the '<em><b>Colors By Instance</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.settings.ColorEntryContainer}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Colors By Instance</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Colors By Instance</em>' reference list.
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getModelSettings_ColorsByInstance()
	 * @model
	 * @generated
	 */
	EList<ColorEntryContainer> getColorsByInstance();

} // ModelSettings
