/**
 * *******************************************************************************
 * Copyright (c) 2019 Robert Bosch GmbH and others.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     Robert Bosch GmbH - initial API and implementation
 * *******************************************************************************
 */

package templates.m2m.sw

import com.google.inject.Inject
import com.inchron.realtime.root.model.Component
import org.eclipse.app4mc.amalthea.model.Process
import org.eclipse.app4mc.amalthea.model.Runnable
import templates.AbstractAmaltheaInchronTransformer
import com.google.inject.Singleton

@Singleton
class RunnableTransformer extends AbstractAmaltheaInchronTransformer {

	//var AmltCacheModel cacheModel

	@Inject RunnableItemTransformer runnableItemTransformer

	def create inchronModelFactory.createFunction createFunction(Component inchronComponent, Process amltTask,
		Runnable amltRunnable) {

		//cacheModel = customObjsStore.getInstance(AmltCacheModel)

		inchronComponent.functions.add(it)

		it.name = amltRunnable.name + "-" + amltTask.name

		val inchronCallGraph = inchronModelFactory.createCallGraph

		it.callGraph = inchronCallGraph

		val inchronCallSequence = inchronModelFactory.createCallSequence

		inchronCallSequence.name = "CS"

		inchronCallGraph.graphEntries.add(inchronCallSequence)

		amltRunnable?.runnableItems?.forEach [ amltRunnableItem |
			
			inchronCallSequence.calls.addAll(runnableItemTransformer.transformRunnableItem(inchronComponent, amltTask,	amltRunnableItem))
	 
		]
	}
}
