/**
 ********************************************************************************
 * Copyright (c) 2018-2019 Robert Bosch GmbH.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     Robert Bosch GmbH - initial API and implementation
 ********************************************************************************
 */

package org.eclipse.app4mc.transformation.application.base;

import org.eclipse.app4mc.transformation.extensions.AbstractTransformationInjectorModule;
import org.eclipse.app4mc.transformation.extensions.executiontype.IModelToModelConfig;
import org.eclipse.app4mc.transformation.extensions.executiontype.IModelToTextConfig;

public class TransformationConfig {

	private String id;

	private AbstractTransformationInjectorModule injectorModule;

	private IModelToModelConfig model2ModelConfig;

	private IModelToTextConfig model2TextConfig;

	public AbstractTransformationInjectorModule getInjectorModule() {
		return injectorModule;
	}

	public void setInjectorModule(AbstractTransformationInjectorModule injectorModule) {
		this.injectorModule = injectorModule;
	}

	public IModelToModelConfig getModel2ModelConfig() {
		return model2ModelConfig;
	}

	public void setModel2ModelConfig(IModelToModelConfig model2ModelConfig) {
		this.model2ModelConfig = model2ModelConfig;
	}

	public IModelToTextConfig getModel2TextConfig() {
		return model2TextConfig;
	}

	public void setModel2TextConfig(IModelToTextConfig model2TextConfig) {
		this.model2TextConfig = model2TextConfig;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

}
