/**
 ********************************************************************************
 * Copyright (c) 2017-2020 Robert Bosch GmbH and others.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     Robert Bosch GmbH - initial API and implementation
 ********************************************************************************
 */
package org.eclipse.app4mc.sca.ui.util;


/**
 * Constants class to contain all the constants used in ui features
 */
public final class SCAToolsPreferenceConstants {

  /**
   * Private Constructor
   */
  private SCAToolsPreferenceConstants() {
    // Private constructor
  }

  /**
   * SCA Tool id
   */
  public static final String SCA_TOOL_ID = "SCATOOLs";

  /**
   * default directory of the log file
   */
  public static final String DEFAULT_DIRECTORY = System.getProperty("user.home");

  /**
   * preference name of the log file
   */
  public static final String TEXT_LOGFILENAME = "LOG_FILE_NAME";

  /**
   * preference name of the log file directory
   */
  public static final String TEXT_LOGFILEDIRECTORY = "LOG_FILE_DIRECTORY";

  /**
   * preference name of the radio buttons
   */
  public static final String SCA_LOGGER = "SCA_LOGGER";

  /**
   * preference page description
   */
  public static final String PREFERENCE_PAGE_DESCRIPTION = "General settings for multicore tools";

  /**
   * Log File radio button.
   */
  public static final String LOG_FILE = "Log File";


  /**
   * Error Log radio button.
   */
  public static final String ERROR_LOG = "Error Log";

  /**
   * Eclipse Console radio button.
   */
  public static final String ECLIPSE_CONSOLE = "Eclipse Console";

  /**
   * Problems Log radio button.
   */
  public static final String PROBLEMS_LOG = "Problems Log";

  /**
   * Debug mode check box label
   */
  public static final String DEBUG_MODE_LABEL = "Enable/Disable debug mode";
  /**
   * Debug mode key
   */
  public static final String DEBUG_MODE = "DEBUG_MODE";

  /**
   * OPT export failed message
   */
  public static final String OPT_EXPORT_FAILED = "";
  /**
   * OPT export success message
   */
  public static final String OPT_EXPORT_SUCCESS = "Preferences appended to the given file successfully";
  /**
   * Message to be displayed when the file name or the tool id is empty
   */
  public static final String EMPTY_FILE_OR_TOOL_ID = "Tool ID and Input file path cannot be empty or null";
  /**
   * Message to be displayed when the extension of the file provided is invalid
   */
  public static final String INVALID_EXT =
      "The input file should have .opt extension. Create an opt file and try again";
  /**
   * Message to be displayed when the file provided is invalid
   */
  public static final String INVALID_FILE = "No file exists in the path provided. Create an opt file and try again";
  /**
   * Message to be displayed when the tood id provided is invalid
   */
  public static final String INVALID_TOOLID = "Invalid tool id. Please check and retry";
  /**
   * Options file extension
   */
  public static final String OPTIONS_FILE_EXT = ".opt";


}
