/**
 ********************************************************************************
 * Copyright (c) 2017-2020 Robert Bosch GmbH and others.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     Robert Bosch GmbH - initial API and implementation
 ********************************************************************************
 */
package org.eclipse.app4mc.sca2amalthea.ui.preferences;

import java.util.Arrays;
import java.util.List;

import org.eclipse.app4mc.sca.ui.preferences.interfaces.IExportPreferences;
import org.eclipse.app4mc.sca2amalthea.utils.constants.SCA2AmaltheaConstants;
import org.eclipse.jface.preference.IPreferenceStore;

/**
 */
public class SCAToAmaltheaExportPreferenceList implements IExportPreferences {


  /**
   * The private constructor
   */
  public SCAToAmaltheaExportPreferenceList() {
    // empty private constructor
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public List<String> keysToExport() {
    String[] prefToSave = { // NOSONAR not significant
        SCA2AmaltheaConstants.ENABLE_STRUCT_MEMBER,
        SCA2AmaltheaConstants.ENABLE_OPTIONAL_FIELDS,
        SCA2AmaltheaConstants.AST_PATH,
        SCA2AmaltheaConstants.OUTPUT_PATH,
        SCA2AmaltheaConstants.TASK_INFO,
        SCA2AmaltheaConstants.BLOG,
        SCA2AmaltheaConstants.HDIR_LIST,
        SCA2AmaltheaConstants.LOCK_INFO };
    return Arrays.asList(prefToSave);
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public IPreferenceStore getPreferenceStore() {
    return org.eclipse.app4mc.sca2amalthea.utils.Activator.getDefault().getPreferenceStore();
  }
}
