/**
 ********************************************************************************
 * Copyright (c) 2017-2020 Robert Bosch GmbH and others.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     Robert Bosch GmbH - initial API and implementation
 ********************************************************************************
 */
package org.eclipse.app4mc.sca2amalthea.ui.util;


/**
 * This class defines constants which are used in SCAToAmaltheaPreferencePage implementation.
 */
public final class SCAToAmaltheaPreferencePageConstants {

  /**
   * Private Constructor
   */
  private SCAToAmaltheaPreferencePageConstants() {
    // Private constructor
  }


  /**
   * Tool Tip message for the Output Directory Path field.
   */
  public static final String OUTPUT_PATH_DEFAULT_MESSAGE =
      "By Default all the output files will be present in sca2amalthea directory which is present inside the (Project directory)/_bin/sca2amlthea";


  /**
   * Tool Tip message for the Task Information File field.
   */
  public static final String TASK_INFO_FILE_DEFAULT_MEAASGE = "By default all functions are treated as runnables";

  /**
   * Tool Tip message for the Build Command Log File field.
   */
  public static final String BUILD_LOG_FILE_DEFAULT_MESSAGE = "By default the c files from project directory are used";


  /**
   * Tool Tip message for the Header Directories field.
   */
  public static final String HEADER_TEXT_FILE_DEFAULT_MESSAGE =
      "By default the header files from the project directory are used";

  /**
   * Tool Tip message for the Lock Function File field.
   */
  public static final String LOCK_FUNCTIONS_DEFAULT_MESSAGE = "By default an internal  lock function file will be used";

  /**
   * Configure optional fields check box text
   */
  public static final String CONFIGURE = "Configure optional fields";

  /**
   * Browse button text.
   */
  public static final String BROWSE = "Browse...";

}
