/* ========================================================================
 * PlantUML : a free UML diagram generator
 * ========================================================================
 *
 * (C) Copyright 2009-2014, Arnaud Roques
 *
 * Project Info:  http://plantuml.sourceforge.net
 * 
 * This file is part of PlantUML.
 *
 * THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS ECLIPSE PUBLIC
 * LICENSE ("AGREEMENT"). [Eclipse Public License - v 1.0]
 * 
 * ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
 * RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.
 * 
 * You may obtain a copy of the License at
 * 
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 *
 * Original Author:  Arnaud Roques
 */
package net.sourceforge.plantuml.asciiart;

import java.util.Collection;

public interface UmlCharArea extends BasicCharArea {

	int STICKMAN_HEIGHT = 5;
	int STICKMAN_UNICODE_HEIGHT = 6;

	void drawBoxSimple(int x, int y, int width, int height);

	void drawBoxSimpleUnicode(int x, int y, int width, int height);

	void drawNoteSimple(int x, int y, int width, int height);

	void drawNoteSimpleUnicode(int x, int y, int width, int height);

	void drawStickMan(int x, int y);

	void drawStickManUnicode(int x, int y);

	void drawStringsLR(Collection<? extends CharSequence> strings, int x, int y);

}
